/*************************************************************************
** STR V3.1                                                              **
** See.c                                                                 **
** Copyright (C) 2012  Jean-Marc Drezet                                  **
**                                                                       **
**  This library is free software; you can redistribute it and/or        **
**  modify it under the terms of the GNU Library General Public          **
**  License as published by the Free Software Foundation; either         **
**  version 2 of the License, or (at your option) any later version.     **
**                                                                       **
**  This library is distributed in the hope that it will be useful,      **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    **
**  Library General Public License for more details.                     **
**                                                                       **
**  You should have received a copy of the GNU Library General Public    **
**  License along with this library; if not, write to the Free           **
**  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   **
**                                                                       **
** Please mail any bug reports/fixes/enhancements to me at:              **
**      drezet@math.jussieu.fr                                           **
** or                                                                    **
**      Jean-Marc Drezet                                                 **
**      Institut de Mathematiques de Jussieu                             **
**      UMR 7586 du CNRS                                                 **
**      4, place Jussieu                                                 **
**      75252 Paris                                                      **
**      France                                                           **
**                                                                       **
**************************************************************************/
#include <stdio.h>
#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#define comp(s1,s2) (!strcmp((s1),(s2)))



/*--------------------------------------------------------------------
--------------------------------------------------------------------*/
char           *
ch_copy(char *s)
{
    char           *t;
    int             slen;

    slen = strlen(s);
    t = (char *) malloc((size_t) (slen + 1) * sizeof(char));
    memcpy(t, s, slen);
    t[slen] = 0;
    return t;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
--------------------------------------------------------------------*/
char           *
ch_copy_int(int i0)
{
    char            h[20];

    memset(h, 0, 20);
    sprintf(h, "%d", i0);
    return ch_copy(h);
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
    donne les faramètres d'un fichier
    *lin : nombre de lignes
    *line_s : longueur maximale d'une ligne
--------------------------------------------------------------------*/
void
file_param(FILE *S, int *lin, int *line_s)
{
    char            ch1;
    int             i,
                    j,
                    jmax;

    i = 0;
    j = 0;
    jmax = 0;

    while (fread(&ch1, 1, 1, S) == 1) {
        if (ch1 == '\n') {
            i++;
            if (jmax < j)
                jmax = j;
            j = 0;
        }
        else
            j++;
    }

    lin[0] = i;
    line_s[0] = jmax;
    rewind(S);
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
--------------------------------------------------------------------*/
int
main(int argc, char *argv[])
{
    FILE           *S,
                   *init;
    pid_t           A;
    char           *base_dir,
                   *base_dir2,
                   *init_file,
                   *init_file2,
                   *file_extens,
                   *file_extens2,
                   *file_extensb,
                   *file_extensb2,
                   *tmpdir,
                   *decompr,
                   *view_ar,
                   *view_ps,
                   *view_dvi,
                   *view_djvu,
                   *view_pdf,
                   *k,
                   *k0,
                    kk[5000],
                   *PID,
                  **ndir,
                  **type_f;
    int             iw,
                    i0,
                    l,
                    lin,
                    j,
                    j0,
                    j1,
                    n;
    size_t          N;

    A = getpid();
    PID = ch_copy_int((int) A);
    if (argc < 2) {
        printf("Nombre d'arguments incorrect\n");
        return 1;
    }
    init_file = ch_copy(".listerc3");
    l = strlen(getenv("HOME")) + strlen(init_file) + 10;
    init_file2 = (char *) malloc((size_t) l * sizeof(char));
    memset(init_file2, 0, l);
    sprintf(init_file2, "%s/%s", getenv("HOME"), init_file);
    free(init_file);
    init = fopen(init_file2, "r");
    if (init == NULL) {
        printf("Fichier ~/.listerc3 absent\n");
        return 1;
    }
    file_param(init, &lin, &j);
    j += 2;
    j0 = j;
    file_extens = (char *) malloc((size_t) j * sizeof(char *));
    file_extens2 = (char *) malloc((size_t) j * sizeof(char *));
    file_extensb = (char *) malloc((size_t) j * sizeof(char *));
    file_extensb2 = (char *) malloc((size_t) j * sizeof(char *));
    base_dir = (char *) malloc((size_t) j * sizeof(char *));
    base_dir2 = (char *) malloc((size_t) j * sizeof(char *));
    tmpdir = (char *) malloc((size_t) j * sizeof(char *));
    decompr = (char *) malloc((size_t) j * sizeof(char *));
    view_ar = (char *) malloc((size_t) j * sizeof(char *));
    view_ps = (char *) malloc((size_t) j * sizeof(char *));
    view_dvi = (char *) malloc((size_t) j * sizeof(char *));
    view_djvu = (char *) malloc((size_t) j * sizeof(char *));
    view_pdf = (char *) malloc((size_t) j * sizeof(char *));
    memset(file_extens, 0, j);
    memset(file_extens2, 0, j);
    memset(file_extensb, 0, j);
    memset(file_extensb2, 0, j);
    memset(base_dir, 0, j);
    memset(base_dir2, 0, j);
    memset(tmpdir, 0, j);
    memset(decompr, 0, j);
    memset(view_ar, 0, j);
    memset(view_ps, 0, j);
    memset(view_dvi, 0, j);
    memset(view_djvu, 0, j);
    memset(view_pdf, 0, j);
    if (fscanf(init, "%s", base_dir) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    if (fscanf(init, "%s", base_dir2) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    if (fscanf(init, "%s", file_extens) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    if (fscanf(init, "%s", file_extens2) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    if (fscanf(init, "%s", file_extensb) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    if (fscanf(init, "%s", file_extensb2) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    if (fscanf(init, "%s", tmpdir) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    if (fscanf(init, "%s", decompr) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    if (fscanf(init, "%s", view_ar) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    if (fscanf(init, "%s", view_ps) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    if (fscanf(init, "%s", view_dvi) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    if (fscanf(init, "%s", view_djvu) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    if (fscanf(init, "%s", view_pdf) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        return 1;
    }
    fclose(init);
    ndir = NULL;
    type_f = NULL;
    k = NULL;
    k0 = NULL;

    if (comp(argv[1], "-a") != 1) {
        iw = 0,
        i0 = atoi(argv[1]);
        k0 = (char *) malloc((size_t) (100 + j) * sizeof(char));
        memset(k0, 0, 100 + j);
        sprintf(k0, "%s/liste.lst", base_dir);
        S = fopen(k0, "r");
        if (S == NULL) {
            printf("Fichier liste.lst absent\n");
            return 1;
        }
        file_param(S, &lin, &j);
        lin += 2;
        j += 2;
        ndir = (char **) malloc((size_t) lin * sizeof(char *));

        for (n = 0; n < lin; n++) {
            ndir[n] = (char *) malloc((size_t) j * sizeof(char));
            memset(ndir[n], 0, j);
        }

        printf("\n");
        n = 0;

        while (fscanf(S, "%s", ndir[n]) == 1) {
            n++;
        }

        if (i0 > n || i0 < 1) {
            printf("Numero d'article incorrect\n");
            return 1;
        }

        j1 = 100 + j + j0;
        k = (char *) malloc((size_t) j1 * sizeof(char));
        memset(k, 0, j1);
        sprintf(k, "%s/%s", base_dir2, ndir[i0 - 1]);
        memset(kk, 0, j1);
        sprintf(kk, "cp %s %s%s.%s" , k, tmpdir, PID, file_extens);
        system(kk);
        memset(kk, 0, j1);
        sprintf(kk, "%s %s%s.%s", decompr, tmpdir, PID, file_extens);
        system(kk);
        memset(kk, 0, j1);
        sprintf(kk, "%s %s%s.%s", view_ar, tmpdir, PID, file_extens2);
        system(kk);
        memset(kk, 0, j1);
        sprintf(kk, "rm -f %s%s.%s", tmpdir, PID, file_extens2);
        system(kk);
    }
    else {
        iw = 1;
        if (argc < 3) {
            printf("Argument manquant\n");
            return 1;
        }
        i0 = atoi(argv[2]);
        k0 = (char *) malloc((size_t) (100 + j) * sizeof(char));
        memset(k0, 0, 100 + j);
        sprintf(k0, "%s/liste3b.lst", base_dir);
        S = fopen(k0, "r");
        if (S == NULL) {
            printf("Fichier liste3b.lst absent\n");
            return 1;
        }
        printf("\n");
        file_param(S, &lin, &j);
        j += 2;
        lin += 2;
        ndir = (char **) malloc((size_t) lin * sizeof(char *));
        type_f = (char **) malloc((size_t) lin * sizeof(char *));

        for (n = 0; n < lin; n++) {
            ndir[n] = (char *) malloc((size_t) j * sizeof(char));
            memset(ndir[n], 0, j);
            type_f[n] = (char *) malloc((size_t) j * sizeof(char));
            memset(type_f[n], 0, j);
        }

        n = 0;

        while (getline(&ndir[n], &N, S) != -1 &&
            getline(&type_f[n], &N, S) != -1) {
            ndir[n][strlen(ndir[n]) - 1] = 0;
            type_f[n][strlen(type_f[n]) - 1] = 0;
            n++;
        }

        if (i0 > n || i0 < 1) {
            printf("Numero d'article incorrect\n");
            return 1;
        }
        j1 = 100 + j + j0;
        k = (char *) malloc((size_t) j1 * sizeof(char));
        memset(k, 0, j1);
        sprintf(k, "%s/divers/%s", base_dir2, ndir[i0 - 1]);
        if (comp(type_f[i0 - 1], "ps") == 1) {
            memset(kk, 0, j1);
            sprintf(kk, "cp %s %s%s.%s" , k, tmpdir, PID, file_extens);
            system(kk);
            memset(kk, 0, j1);
            sprintf(kk, "%s %s%s.%s", decompr, tmpdir, PID, file_extens);
            system(kk);
            memset(kk, 0, j1);
            sprintf(kk, "%s %s%s.%s",view_ps, tmpdir, PID, file_extens2);
            system(kk);
            memset(kk, 0, j1);
            sprintf(kk, "rm -f %s%s.%s", tmpdir, PID, file_extens2);
            system(kk);
        }
        else {
            if (comp(type_f[i0 - 1], "dvi") == 1) {
                memset(kk, 0, j1);
                sprintf(kk, "cp %s %s%s.%s" , k, tmpdir, PID, file_extensb);
                system(kk);
                memset(kk, 0, j1);
                sprintf(kk, "%s %s%s.%s",decompr, tmpdir, PID, file_extensb);
                system(kk);
                memset(kk, 0, j1);
                sprintf(kk, "%s %s%s.%s",view_dvi, tmpdir, PID, file_extensb2);
                system(kk);
                memset(kk, 0, j1);
                sprintf(kk, "rm -f %s%s.%s", tmpdir, PID, file_extensb2);
                system(kk);
            }
            else {
                if (comp(type_f[i0 - 1], "pdf") == 1) {
                    memset(kk, 0, j1);
                    sprintf(kk, "%s %s",view_pdf, k);
                    system(kk);
                }
                else {
                    if (comp(type_f[i0 - 1], "djvu") == 1) {
                        memset(kk, 0, j1);
                        sprintf(kk, "%s %s",view_djvu, k);
                        system(kk);
                    }
                }
            }
        }

    }

    fclose(S);
    free(file_extens);
    free(file_extens2);
    free(file_extensb);
    free(file_extensb2);
    free(base_dir);
    free(base_dir2);
    free(tmpdir);
    free(decompr);
    free(view_ar);
    free(view_ps);
    free(view_dvi);
    free(view_djvu);
    free(view_pdf);
    free(init_file2);
    free(PID);
    if (ndir != NULL) {
        for (i0 = 0; i0 < lin; i0++)
            free(ndir[i0]);
        free(ndir);
    }
    if (type_f != NULL) {
        for (i0 = 0; i0 < lin; i0++)
            free(type_f[i0]);
        free(type_f);
    }
    if (k != NULL)
        free(k);
    if (k0 != NULL)
        free(k0);
    return 0;
}
/*------------------------------------------------------------------*/
