;/*************************************************************************
** STR V3.1                                                              **
** command1.c                                                            **
** Copyright (C) 2012  Jean-Marc Drezet                                  **
**                                                                       **
**  This library is free software; you can redistribute it and/or        **
**  modify it under the terms of the GNU Library General Public          **
**  License as published by the Free Software Foundation; either         **
**  version 2 of the License, or (at your option) any later version.     **
**                                                                       **
**  This library is distributed in the hope that it will be useful,      **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    **
**  Library General Public License for more details.                     **
**                                                                       **
**  You should have received a copy of the GNU Library General Public    **
**  License along with this library; if not, write to the Free           **
**  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   **
**                                                                       **
** Please mail any bug reports/fixes/enhancements to me at:              **
**      drezet@math.jussieu.fr                                           **
** or                                                                    **
**      Jean-Marc Drezet                                                 **
**      Institut de Mathematiques de Jussieu                             **
**      UMR 7586 du CNRS                                                 **
**      4, place Jussieu                                                 **
**      75252 Paris                                                      **
**      France                                                           **
**                                                                       **
**************************************************************************/
#include "liste.h"
#include <dirent.h>
#include <string.h>
#include "interp.h"
extern char   **Squel;






/*--------------------------------------------------------------------

--------------------------------------------------------------------*/
int
ls_dir(int argc, char *argv[])
{
    int             i,
                    ind,
                    iw,
                    iw2,
                    j,
                    j0,
                    k0,
                    n,
                    nfic,
                    lin,
                    jmax,
                    n_dir,
                    i_len,
                    len,
                    o;
    char           *k,
                   *kw,
                   *N0,
                  **NN,
                  **NN0;
    DIR            *dirw;
    struct dirent  *direntw;
    flow_data      *flow_interp;
    FILE           *S;

    INIT_FLOW(flow_interp);
    dirw = opendir(argv[1]);
    if (dirw == NULL) {
        error_mess(flow_interp, 6);
        return 1;
    }
    n_dir = 0;
    while (readdir(dirw) != NULL)
        n_dir++;
    closedir(dirw);
    i_len = 100 + strlen(argv[2]);
    k = (char *) malloc((size_t) i_len * sizeof(char));
    NN = (char **) malloc((size_t) (n_dir + 1) * sizeof(char *));
    kw = NULL;


/*------------------------------------------------------
    Lecture du rpertoire argv[1]
------------------------------------------------------*/
    i = 0;
    j = 0;
    dirw = opendir(argv[1]);

next2w: direntw = readdir(dirw);  /* nouvelle entre du rpertoire */
    if (direntw == NULL) {
        closedir(dirw);
        goto endw;
    }
    if (direntw->d_type == DT_REG) {
        if (direntw->d_name[0] == '.')
            goto next2w;
        n = strlen(direntw->d_name);

/*----- on teste si le fichier est un .html ----*/
        if (n < 6)
            goto next2w;
        if (direntw->d_name[n - 1] != 'l' || direntw->d_name[n - 2] != 'm' ||
            direntw->d_name[n - 3] != 't' || direntw->d_name[n - 4] != 'h' ||
            direntw->d_name[n - 5] != '.')
            goto next2w;
/*        print(flow_interp, "%s\n", direntw->d_name);*/
        NN[i] = ch_copy(direntw->d_name);
        i++;
    }
    goto next2w;
/*----------------------------------------------------*/


endw: nfic = i;

/*----- lecture de LIST.STR --------------------------*/
    k0 = -1;
    j0 = -1;
    memset(k, 0, i_len);
    sprintf(k, "rm -f %s/DEL.STR", argv[2]);
    system(k);
    memset(k, 0, i_len);
    sprintf(k, "rm -f %s/NEW.STR", argv[2]);
    system(k);
    memset(k, 0, i_len);
    sprintf(k, "%s/LIST.STR", argv[2]);
    S = fopen(k, "r");

    if (S != NULL) {
        file_param(S, &lin, &jmax, &len);
        jmax +=2;
        kw = (char *) malloc((size_t) jmax * sizeof(char));
        NN0 = (char **) malloc((size_t) (lin + 2) * sizeof(char *));
        memset(kw, 0, jmax);
        if (fgets(kw, jmax, S) != NULL) {
            k0 = strtol(kw, NULL, 10);
            j0 = k0;
            k0 = -1;

            for (i = 0; i < j0; i++) {
                if (fgets(kw, jmax, S) != NULL) {
                    k0++;
                    NN0[k0] = ch_copy(kw);
                    j = strlen(NN0[k0]);
                    NN0[k0][j - 1] = 0;
                    memset(kw, 0, jmax);
                }
            }

            if (k0 != j0 - 1)
                k0 = 0;
        }
        fclose(S);
        S = NULL;
        free(kw);
    }
/*----------------------------------------------*/


/*--- mise en ordre des entres du rpertoire --*/
    for (i = 0; i < nfic - 1; i++) {
        for (j = i + 1; j < nfic; j++) {
            if (est_avantb(NN[i], NN[j]) == 0) {
                N0 = NN[i];
                NN[i] = NN[j];
                NN[j] = N0;
            }
        }
    }
/*----------------------------------------------*/


/*--- comparaison du contenu de LIST.STR et du contenu
                                du rpertoire --*/
    iw = 0;
    iw2 = 0;

    for (i = 0; i <= k0; i++) {
        ind = 0;

        for (o = 0; o < nfic; o++) {
            if (comp(NN0[i], NN[o]) == 1) {
                ind = 1;
                break;
            }
        }

        if (ind == 0) {
            printf("supprim : %s\n", NN0[i]);
            if (iw == 0) {
                memset(k, 0, i_len);
                sprintf(k, "%s/DEL.STR", argv[2]);
                S = fopen(k, "w");
            }
            fprintf(S, "%s\n", NN0[i]);
            iw = 1;
            iw2 = 1;
        }
    }

    iw = 0;

    for (i = 0; i < nfic; i++) {
        ind = 0;

        for (o = 0; o <= k0; o++) {
            if (comp(NN[i], NN0[o]) == 1) {
                ind = 1;
                break;
            }
        }

        if (ind == 0) {
            printf("nouveau : %s\n", NN[i]);
            if (iw == 0) {
                if (S != NULL)
                    fclose(S);
                memset(k, 0, i_len);
                sprintf(k, "%s/NEW.STR", argv[2]);
                S = fopen(k, "w");
            }
            fprintf(S, "%s\n", NN[i]);
            iw = 1;
            iw2 = 1;
        }
    }
/*----------------------------------------------*/


/*--- criture ventuelle du nouveau LIST.STR --*/
    if (iw2 == 1) {
        fclose(S);
        memset(k, 0, i_len);
        sprintf(k, "%s/LIST.STR", argv[2]);
        S = fopen(k, "w");
        fprintf(S, "%d\n", nfic);
        for (i = 0; i < nfic; i++)
            fprintf(S, "%s\n", NN[i]);
        fclose(S);
    }
/*----------------------------------------------*/


    free(k);
    for (i = 0; i < nfic; i++)
        free(NN[i]);
    free(NN);
    for (i = 0; i <= k0; i++)
        free(NN0[i]);
    if (k0 >= 0)
        free(NN0);
    return 0;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------

--------------------------------------------------------------------*/
int
lect_DB(int argc, char *argv[])
{
    int             i,
                    nb,
                    i0,
                    ind,
                    i_len,
                    i_len2,
                    iw;
    char            ch1,
                   *k,
                   *k2,
                   *kk[4],
                  **e;
    math_rec       *D;
    flow_data      *flow_interp;
    FILE           *S;

    INIT_FLOW(flow_interp);
    ind = 0;
    i_len = strlen(argv[1]) + 100;
    i_len2 = strlen(argv[2]) + 100;
    n_art = 0;
    k = (char *) malloc((size_t) i_len * sizeof(char));
    k2 = (char *) malloc((size_t) i_len2 * sizeof(char));
    memset(k, 0, i_len);
    sprintf(k, "%s/DB.STR", argv[1]);
    S = fopen(k, "r");
    if (S == NULL) {
        error_mess(flow_interp, 8);
        free(k);
        free(k2);
        return 1;
    }
    fscanf(S, "%d", &nb);
    fread(&ch1, 1, 1, S);
    memset(k2, 0, i_len2);
    sprintf(k2, "%s[%d]", argv[2], nb);

    kk[0] = (char *) flow_interp;
    kk[1] = ch_copy("objdef");
    kk[2] = ch_copy("0");
    kk[3] = ch_copy(k2);
    i0 = obj_create(3, kk + 1);
    free(kk[1]);
    free(kk[2]);
    free(kk[3]);
    if (i0 == -1) {
        error_mess(flow_interp, 1);
        ind = 1;
        goto end;
    }

    for (i = 1; i <= nb; i++) {
        memset(k2, 0, i_len2);
        sprintf(k2, "%s[%d]", argv[2], i);
        iw = sketch_obj(k2, &i0, flow_interp);
        if (iw != 1) {
            error_mess(flow_interp, 2);
            ind = 1;
            goto end;
        }
        e = (char **) Obj[0][i0].adresse;
        D = (math_rec *) malloc((size_t) sizeof(math_rec));
        e[0] = (char *)D;
        lec_DB_STR(S, D);
    }

end : fclose(S);
    free(k);
    free(k2);
    n_art = nb;
    return ind;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------

--------------------------------------------------------------------*/
int
update_DB(int argc, char *argv[])
{
    int             i,
                    j,
                    nb,
                    ndel,
                    nnew,
                    i0,
                    ind,
                    i_len,
                    i_len2,
                    len,
                    lin,
                    line_s,
                    iw,
                   *idel;
    char            ch1,
                   *k,
                   *k2,
                   *kk[4],
                  **NNnew,
                  **NNdel,
                  **e,
                   *w;
    math_rec      **D0,
                  **D1,
                   *D;
    flow_data      *flow_interp;
    FILE           *S,
                   *S1;

    INIT_FLOW(flow_interp);
    ndel = 0;
    nnew = 0;
    ind = 0;
    NNdel = NULL;
    NNnew = NULL;
    idel = NULL;
    D0 = NULL;
    D1 = NULL;
    i_len = strlen(argv[1]) + 100;
    i_len2 = strlen(argv[2]) + 100;
    k = (char *) malloc((size_t) i_len * sizeof(char));
    k2 = (char *) malloc((size_t) i_len2 * sizeof(char));
    memset(k, 0, i_len);

/*-------------------------------------
    lecture de DB.STR et cration des articles
-------------------------------------*/
    kk[0] = (char *) flow_interp;
    kk[1] = ch_copy("lect_DB");
    kk[2] = ch_copy(argv[1]);
    sprintf(k, "_update_%d", n_up);
    kk[3] = ch_copy(k);
    i0 = lect_DB(3, kk + 1);
    free(kk[1]);
    free(kk[2]);
    free(kk[3]);
    if (i0 != 0)
        n_art = 0;
    memset(k, 0, i_len);
    sprintf(k, "%s/DB.STR", argv[1]);
    S = fopen(k, "w");
    if (S == NULL) {
        error_mess(flow_interp, 8);
        ind = 1;
        goto end;
    }
    if (n_art > 0) {
        D0 = (math_rec **) malloc((size_t) n_art * sizeof(math_rec *));
        idel = (int *) malloc((size_t) n_art * sizeof(int));
    }
    for (i = 0; i < n_art; i++)
        idel[i] = 0;

    for (i = 0; i < n_art; i++) {
        memset(k, 0, i_len);
        sprintf(k, "_update_%d[%d]", n_up, i + 1);
        iw = sketch_obj(k, &i0, flow_interp);
        if (iw != 1) {
            error_mess(flow_interp, 2);
            ind = 2;
            fclose(S);
            goto end;
        }
        e = (char **) Obj[0][i0].adresse;
        D0[i] = (math_rec *) e[0];
    }
/*-----------------------------------*/



/*-------------------------------------
    Lecture de la liste des articles supprims
-------------------------------------*/
    memset(k, 0, i_len);
    sprintf(k, "%s/DEL.STR", argv[1]);
    S1 = fopen(k, "r");
    if (S1 != NULL) {
        file_param(S1, &lin, &line_s, &len);
        lin += 2;
        line_s += 2;
        NNdel = (char **) malloc((size_t) lin * sizeof(char *));
        memset(NNdel, 0, lin * sizeof(char *));
        ndel = 0;
        j = 0;
        i0 = 0;
        while (fread(&ch1, 1, 1, S1) == 1) {
            if (ch1 != '\n') {
                if (i0 == 0) {
                    NNdel[ndel] = (char *) malloc((size_t) line_s *
                        sizeof(char));
                    memset(NNdel[ndel], 0, line_s);
                    i0 = 1;
                }
                if (j < line_s)
                    NNdel[ndel][j++] = ch1;
            }
            else {
                ndel++;
                j = 0;
                i0 = 0;
            }
        }
        fclose(S1);
    }
/*-----------------------------------*/



/*-------------------------------------
    Lecture de la liste des nouveaux articles
-------------------------------------*/
    memset(k, 0, i_len);
    sprintf(k, "%s/NEW.STR", argv[1]);
    S1 = fopen(k, "r");
    if (S1 != NULL) {
        file_param(S1, &lin, &line_s, &len);
        lin += 2;
        line_s += 2;
        NNnew = (char **) malloc((size_t) lin * sizeof(char *));
        memset(NNnew , 0, lin * sizeof(char *));
        nnew = 0;
        j = 0;
        i0 = 0;
        while (fread(&ch1, 1, 1, S1) == 1) {
            if (ch1 != '\n') {
                if (i0 == 0) {
                    NNnew[nnew] = (char *) malloc((size_t) line_s *
                        sizeof(char));
                    memset(NNnew[nnew], 0, line_s);
                    i0 = 1;
                }
                if (j < line_s)
                    NNnew[nnew][j++] = ch1;
            }
            else {
                nnew++;
                j = 0;
                i0 = 0;
            }
        }
        fclose(S1);
    }
/*-----------------------------------*/

    memset(k, 0, i_len);

    if (ndel > 0) {
        i0 = 0;

        for (i = 0; i < n_art; i++) {
            if (comp(D0[i]->ref, NNdel[i0]) == 1) {
                idel[i] = 1;
                i0++;
                if (i0 >= ndel)
                    break;
            }
        }
    }

    D1 = (math_rec **) malloc((size_t) (2 * nnew + n_art) * sizeof(math_rec *));
    if (nnew > 0) {
        for (i = 0; i < nnew; i++) {
            D1[i] = (math_rec *) malloc((size_t) sizeof(math_rec));
            D1[i]->fill = 0;
            D1[i]->nb_aut = 0;
            D1[i]->fic = NULL;
            D1[i]->name_aut = NULL;
            D1[i]->name_aut2 = NULL;
            D1[i]->titre = NULL;
            D1[i]->resume = NULL;
            D1[i]->ref = NULL;
            memset(k2, 0, i_len2);
            sprintf(k2, "%s/%s", argv[2], NNnew[i]);
            if (lect_fic_art(k2, D1[i]) > 0) {
                error_mess(flow_interp, 9);
                printf("%s\n", NNnew[i]);
                STR_exit(0);
            }
            D1[i]->ref = ch_copy(NNnew[i]);
        }

        for (i = 0; i < nnew; i++) {
            w = D1[i]->name_aut2[0];
            for (j = i + 1; j < nnew; j++) {
                if (est_avant(D1[j]->name_aut2[0], w) == 1) {
                    D = D1[i];
                    D1[i] = D1[j];
                    D1[j] = D;
                    w = D1[i]->name_aut2[0];
                }
            }
        }
    }
    j = nnew;
    nb = nnew + n_art;

    for (i = nnew; i < nb; i++) /*{*/
        if (idel[i - nnew] == 0)
            D1[j++] = D0[i - nnew];

    nb = j;

    for (i = 0; i < nnew; i++) {
        if (i == 0)
            j = nnew;
        w = D1[i]->name_aut2[0];
        while ((j < nb + i) && est_avantb(w, D1[j]->name_aut2[0]) == 0) {
            j++;
        }
        for (i0 = nb + i; i0 > j; i0--)
            D1[i0] = D1[i0 - 1];
        D1[j] = D1[i];
    }


/*-------------------------------------
    criture du nouveau DB.STR
-------------------------------------*/
    memset(k, 0, i_len);
    fprintf(S, "%d\n", nb);
    for (i = nnew; i < nb + nnew; i++)
        add_DB_STR(S, D1[i]);
    fclose(S);
/*-----------------------------------*/


    memset(k, 0, i_len);
    sprintf(k, "rm -f %s/DEL.STR", argv[1]);
    system(k);
    memset(k, 0, i_len);
    sprintf(k, "rm -f %s/NEW.STR", argv[1]);
    system(k);

end : free(k);
    free(k2);
    if (ndel > 0) {
        for (i = 0; i < ndel; i++)
            free(NNdel[i]);
        free(NNdel);
    }
    if (nnew > 0) {
        for (i = 0; i < nnew; i++)
            free(NNnew[i]);
        free(NNnew);
    }
    if (idel != NULL)
        free(idel);
    if (D0 != NULL)
        free(D0);
    if (D1 != NULL) {
        for (i = 0; i < nnew; i++) {
            if (D1[i]->nb_aut > 0) {
                for (j = 0; j < D1[i]->nb_aut; j++)
                    free(D1[i]->name_aut[j]);
                for (j = 0; j < D1[i]->nb_aut; j++)
                    free(D1[i]->name_aut2[j]);
                free(D1[i]->name_aut);
                free(D1[i]->name_aut2);
                free(D1[i]->titre);
                free(D1[i]->resume);
                if (D1[i]->ref != NULL)
                    free(D1[i]->ref);
                if (D1[i]->fic != NULL)
                    free(D1[i]->fic);
                free(D1[i]);
            }
        }

        free(D1);
   }
    n_up++;
    return ind;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
    Creation des fichiers html correspondant aux articles arXiv
--------------------------------------------------------------------*/
int
make_html(int argc, char *argv[])
{
    int             i,
                    j,
                    nb,
                    o,
                    ii,
                    i0,
                    ind,
                    i_len,
                    iw;
    char            ch1,
                   *k0,
                   *k;
    math_rec       *D;
    flow_data      *flow_interp;
    FILE           *S,
                   *S1;

    INIT_FLOW(flow_interp);
    i_len = 100 + strlen(argv[1]);
    k = (char *) malloc((size_t) i_len * sizeof(char));
    k0 = (char *) malloc((size_t) 10 * sizeof(char));
    k0[1] = 0;
    ind = 0;
    memset(k, 0, i_len);
    sprintf(k, "%s/DB.STR", argv[1]);
    S = fopen(k, "r");
    if (S == NULL) {
        error_mess(flow_interp, 8);
        ind = 1;
        STR_exit(0);
    }
    nb = 0;
    fscanf(S, "%d", &nb);
    if (nb <= 0) {
        error_mess(flow_interp, 10);
        ind = 1;
        fclose(S);
        STR_exit(0);
    }
    fread(&ch1, 1, 1, S);
    D = (math_rec *) malloc((size_t) nb * sizeof(math_rec));
    Dzero(D,nb);
    for (i = 0; i < nb; i++)
        lec_DB_STR(S, &D[i]);
    fclose(S);
    memset(k, 0, i_len);
    sprintf(k, "%s/liste.lst", argv[1]);
    S1 = fopen(k, "w");

    for (i = 0; i < 26; i++) {
        memset(k, 0, i_len);
        k0[0] = 65 + i;
        sprintf(k, "%s/%s.html", argv[1], k0);
        S = fopen(k, "w");
        for (j = 0; j < 7; j++)
            fprintf(S, "%s\n", Squel[j]);

        for (iw = 0; iw < nb; iw++)
            if (D[iw].name_aut2[0][0] == (char) i + 65) {
                memset(k, 0, i_len);
                strcpy(k, D[iw].ref);
                j = strlen(k);
                k[j - 1] = 0;
                k[j - 2] = 0;
                k[j - 3] = 0;
                k[j - 4] = 0;
                strcat(k, "ps.bz2");
                fprintf(S1, "%s\n", k);
                _br_html_0(S);
                fprintf(S, "%d\n", iw + 1);
                _br_html_0(S);
                _B_html_0(S);
                _color_html_0(S, 60, 60, 240);
                _big_html_0(S);

                for (ii = 0; ii < D[iw].nb_aut; ii++) {
                    fprintf(S, "%s\n", D[iw].name_aut[ii]);
                    _br_html_0(S);
                }

                _invbig_html_0(S);
                _invspan_html_0(S);
                _invB_html_0(S);
                _italic_html_0(S);
                fprintf(S, "%s\n", D[iw].titre);
                _invspan_html_0(S);
                _br_html_0(S);
                _br_html_0(S);
                fprintf(S, "%s\n", D[iw].resume);
                _br_html_0(S);
                _br_html_0(S);
                _line_75_html_0(S);
            }

            _br_html_0(S);
            _br_html_0(S);
            _line_100_html_0(S);
            _line_100_html_0(S);
            _br_html_0(S);

            for (iw = 0; iw < nb; iw++) {
                i0 = 0;

                for (o = 1; o < D[iw].nb_aut; o++) {
                    if (D[iw].name_aut2[o][0] == (char) i + 65 && i0 == 0) {
                        i0 = 1;
                        _br_html_0(S);
                        fprintf(S, "%d\n", iw + 1);
                        _B_html_0(S);

                        for (ii = 0; ii < D[iw].nb_aut; ii++) {
                            if (ii > 0 && D[iw].name_aut2[ii][0] ==
                                (char) i + 65) {
                                _color_html_0(S, 60, 60, 240);
                                fprintf(S, " - %s\n", D[iw].name_aut[ii]);
                                _invspan_html_0(S);
                            }
                            else
                                fprintf(S, "- %s\n", D[iw].name_aut[ii]);
                        }

                        _invB_html_0(S);
                        _br_html_0(S);
                        _italic_html_0(S);
                        fprintf(S, "%s\n", D[iw].titre);
                        _invspan_html_0(S);
                        _br_html_0(S);
                        _br_html_0(S);
                        fprintf(S, "%s\n", D[iw].resume);
                        _br_html_0(S);
                        _br_html_0(S);
                        _line_50_html_0(S);
                    }
                }
            }
        fclose(S);
    }

    fclose(S1);
end : free(k);
    free(k0);
    Dfree(D, nb);

    return ind;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------

--------------------------------------------------------------------*/
int
purge_dir(int argc, char *argv[])
{
    int             i,
                    i0;
    char           *k,
                   *k0;
    flow_data      *flow_interp;

    k0 = (char *) malloc((size_t) 10 * sizeof(char));
    sprintf(k0, "X.html");
    INIT_FLOW(flow_interp);
    i0 = strlen(argv[1]) + 1000;
    k = (char *) malloc((size_t) i0 * sizeof(char));
    sprintf(k, "rm -f %s/*.STR", argv[1]);
    system(k);

    for (i = 65; i <= 90; i++) {
        memset(k, 0, i0);
        k0[0] = i;
        sprintf(k, "rm -f %s/%s", argv[1], k0);
        system(k);
    }

    memset(k, 0, i0);
    sprintf(k, "rm -f %s/liste_div.STR", argv[1]);
    system(k);
    memset(k, 0, i0);
    sprintf(k, "rm -f %s/Auteurs/*.html", argv[1]);
    system(k);

    free(k);
    free(k0);
    return 0;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
    Creation des fichiers html correspondant aux autres documents
--------------------------------------------------------------------*/
int
lst_autres(int argc, char *argv[])
{
    FILE           *testf,
                   *testf2,
                   *lst;
    char          **name,
                   *k,
                  **zk0,
                  **zk2,
                  **zk3,
                   *zk4,
                 ***zk0_b,
                 ***zk2_b,
                 ***zk3_b,
                 ***name_b,
                   *LETZ;
    int             i,
                    i_len,
                    lim,
                    i0,
                    ik1,
                    ik2,
                    j,
                    jj,
                    j2,
                    len,
                    o,
                    ind[26],
                  **iz;
    size_t          N;
    flow_data      *flow_interp;

    INIT_FLOW(flow_interp);
    i_len = 100 + strlen(argv[1]);
    k = (char *) malloc((size_t) i_len * sizeof(char));
    memset(k, 0, i_len);
    sprintf(k, "%s/liste_div.lst", argv[1]);
    lst = NULL;
    lst = fopen(k, "r");
    if (lst == NULL) {
        error_mess(flow_interp, 11);
        free(k);
        return 1;
    }
    memset(k, 0, i_len);
    sprintf(k, "%s/liste3b.lst", argv[1]);
    testf2 = fopen(k, "w");
    sprintf(k, "%s/liste_div.html", argv[1]);
    testf = fopen(k, "w");
    for (jj = 0; jj < 7; jj++)
        for (o = 0; o < strlen(Squel[jj]); o++)
            fwrite(&Squel[jj][o], 1, 1, testf);
    file_param(lst, &lim, &i0, &len);
    lim += 2;
    N = i0 + 2;
    zk0 = (char **) malloc((size_t) lim * sizeof(char *));
    name = (char **) malloc((size_t) lim * sizeof(char *));
    memset(zk0, 0, lim * sizeof(char *));
    zk2 = (char **) malloc((size_t) lim * sizeof(char *));
    memset(zk2, 0, lim * sizeof(char *));
    zk3 = (char **) malloc((size_t) lim * sizeof(char *));
    memset(zk3, 0, lim * sizeof(char *));
    zk4 = (char *) malloc((size_t) N * sizeof(char));
    memset(zk4, 0, N);
    zk0[0] = (char *) malloc((size_t) N * sizeof(char));
    memset(zk0[0], 0, N);
    j = 0;

    while (getline(&zk0[j], &N, lst) != -1) {
        name[j] = (char *) malloc((size_t) N * sizeof(char));
        memset(name[j], 0, N);
        if (getline(&name[j], &N, lst) == -1)
            break;
        zk2[j] = (char *) malloc((size_t) N * sizeof(char));
        memset(zk2[j], 0, N);
        if (getline(&zk2[j], &N, lst) == -1)
            break;
        zk3[j] = (char *) malloc((size_t) N * sizeof(char));
        memset(zk3[j], 0, N);
        if (getline(&zk3[j], &N, lst) == -1)
            break;
        ik1 = strlen(name[j]);
        ik2 = strlen(zk2[j]);
        name[j][ik1 - 1] = 0;
        zk2[j][ik2 - 1] = 0;
        memset(zk4, 0, N);
        j++;
        if (getline(&zk4, &N, lst) == -1)
            break;
        zk0[j] = (char *) malloc((size_t) N * sizeof(char));
        memset(zk0[j], 0, N);
    }

    for (i = 0; i < j; i++) {
        o = strlen(name[i]);
        for (jj = 0; jj < o; jj++)
            if (name[i][jj] == 35)
                name[i][jj] = 32;
    }

    iz = (int **) malloc((size_t) 26 * sizeof(int *));

    for (i = 0; i < 26; i++)
        iz[i] = (int *) malloc((size_t) lim * sizeof(int));
    zk0_b = (char ***) malloc((size_t) 26 * sizeof(char **));
    name_b = (char ***) malloc((size_t) 26 * sizeof(char **));
    zk2_b = (char ***) malloc((size_t) 26 * sizeof(char **));
    zk3_b = (char ***) malloc((size_t) 26 * sizeof(char **));

    for (o = 0; o < 26; o++) {
        zk0_b[o] = (char **) malloc((size_t) lim * sizeof(char *));
        name_b[o] = (char **) malloc((size_t) lim * sizeof(char *));
        zk2_b[o] = (char **) malloc((size_t) lim * sizeof(char *));
        zk3_b[o] = (char **) malloc((size_t) lim * sizeof(char *));
    }

    for (o = 0; o < 26; o++)
        ind[o] = 0;

    for (i = 0; i < j; i++) {
        o = name[i][0] - 65;
        if (o >= 0 && o < 26) {
            iz[o][ind[o]] = i;
            ind[o]++;
        }
    }

    for (o = 0; o < 26; o++) {
        for (jj = 0; jj < ind[o]; jj++) {
            ik1 = iz[o][jj];
            zk0_b[o][jj] = zk0[ik1];
            name_b[o][jj] = name[ik1];
            zk2_b[o][jj] = zk2[ik1];
            zk3_b[o][jj] = zk3[ik1];
        }

        for (jj = 0; jj < ind[o]; jj++) {
            ik1 = 0;
            for (j2 = 0; j2 < ind[o] - 1; j2++)
                if (est_avantb(name_b[o][j2 + 1], name_b[o][j2]) == 1)
                    ik1 = 1;
            if (ik1 == 1) {
                for (j2 = 0; j2 < ind[o]; j2++)
                    for (ik2 = j2 + 1; ik2 < ind[o]; ik2++)
                        if (est_avantb(name_b[o][ik2], name_b[o][j2]) == 1) {
                            echange_nom_b(&name_b[o][j2], &name_b[o][ik2]);
                            echange_nom_b(&zk0_b[o][j2], &zk0_b[o][ik2]);
                            echange_nom_b(&zk2_b[o][j2], &zk2_b[o][ik2]);
                            echange_nom_b(&zk3_b[o][j2], &zk3_b[o][ik2]);
                        }
                }
        }
    }

    i = 0;
    LETZ= (char *) malloc((size_t) 3 * sizeof(char));
    LETZ[1] = 0;
    fwrite_html_0(60, testf);
    fwrite_html_0(47, testf);
    fwrite_html_0(65, testf);
    fwrite_html_0(62, testf);
    _fontsize_html_0(3, testf);

    for (o = 0; o < 26; o++) {
        if (o == 13)
            _br_html_0(testf);
        _HREF_deb_html_0(testf);
        fwrite_html_0(35, testf);
        fwrite_html_0(65 + o, testf);
        _HREF_fin_html_0(testf);
        fwrite_html_0(65 + o, testf);
        _invA_html_0(testf);
        _nbsp_html_0(testf);
        _nbsp_html_0(testf);
        _nbsp_html_0(testf);
        _nbsp_html_0(testf);
    }

    _invfont_html_0(testf);
    _invB_html_0(testf);
    _line_100_html_0(testf);

    for (o = 0; o < 26; o++) {
        LETZ[0] = 65 + o;
        _br_html_0(testf);
        _line_100_html_0(testf);
        _fontsize_html_0(2, testf);
        _link_html_0(LETZ, LETZ, testf);
        _invfont_html_0(testf);
        _line_100_html_0(testf);

        for (jj = 0; jj < ind[o]; jj++) {
            fprintf(testf2, "%s", zk0_b[o][jj]);
            fprintf(testf2, "%s", zk3_b[o][jj]);
            _br_html_0(testf);
            _color_html_0(testf, 60, 60, 240);
            _big_html_0(testf);
            memset(k, 0, i_len);
            i++;
            sprintf(k, "%d - %s ", i, name_b[o][jj]);
            _string_html_0(k, testf);
            _invbig_html_0(testf);
            _invspan_html_0(testf);
            _nbsp_html_0(testf);
            _nbsp_html_0(testf);
            _nbsp_html_0(testf);
            _nbsp_html_0(testf);
            _italic_html_0(testf);
            _string_html_0(zk2_b[o][jj], testf);
            _invspan_html_0(testf);
            _br_html_0(testf);
        }
    }

    fclose(lst);
    for (j2 = 33; j2 < 36; j2++)
        for (o = 0; o < strlen(Squel[j2]); o++)
            fwrite(&Squel[j2][o], 1, 1, testf);
    fclose(testf);
    fclose(testf2);

    for (i = 0; i < 26; i++) {
        free(iz[i]);
        free(zk0_b[i]);
        free(name_b[i]);
        free(zk2_b[i]);
        free(zk3_b[i]);
    }

    free(zk0_b);
    free(name_b);
    free(zk2_b);
    free(zk3_b);

    for (i = 0; i < j; i++) {
        free(zk0[i]);
        free(name[i]);
        free(zk2[i]);
        free(zk3[i]);
    }

    free(zk0);
    free(zk2);
    free(zk3);
    free(zk4);
    free(LETZ);
    free(k);
    free(name);
    free(iz);
    return 0;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
    Fait la liste ordonnee des auteurs des articles arXiv
    et des articles correspondant  ces auteurs
--------------------------------------------------------------------*/
int
liste_auteurs_arxiv(int argc, char *argv[])
{
    int             i,
                    i_len,
                    j,
                    nb,
                    o,
                    ii,
                    i0,
                    ind,
                    iw;
    char            ch1,
                   *chk,
                   *k,
                  **liste_aut,
                  **liste_aut2,
                   *kw;
    math_rec       *D;
    flow_data      *flow_interp;
    FILE           *S;

    INIT_FLOW(flow_interp);
    chk = (char *) malloc((size_t) 2 * sizeof(char));
    chk[0] = 35;
    chk[1] = 0;
    o = 0;
    liste_aut = NULL;
    liste_aut2 = NULL;
    i_len = 100 + strlen(argv[1]);
    k = (char *) malloc((size_t) i_len * sizeof(char));
    memset(k, 0, i_len);
    sprintf(k, "%s/DB.STR", argv[1]);
    S = fopen(k, "r");
    if (S == NULL) {
        error_mess(flow_interp, 8);
        ind = 1;
        goto end2;
    }
    nb = 0;
    fscanf(S, "%d", &nb);
    if (nb <= 0) {
        error_mess(flow_interp, 10);
        ind = 1;
        goto end2;
    }
    fread(&ch1, 1, 1, S);
    D = (math_rec *) malloc((size_t) nb * sizeof(math_rec));
    Dzero(D,nb);

    for (i = 0; i < nb; i++) {
        lec_DB_STR(S, &D[i]);
        o += D[i].nb_aut;
    }

    fclose(S);
    liste_aut = (char **) malloc((size_t) o * sizeof(char *));
    liste_aut2 = (char **) malloc((size_t) o * sizeof(char *));

    for (i = 0; i < o; i++) {
        liste_aut[i] = NULL;
        liste_aut2[i] = NULL;
    }

    i0 = 0;

    for (i = 0; i < nb; i++)
        for (j = 0; j < D[i].nb_aut; j++)
            liste_aut[i0++] = ch_copy((D[i].name_aut2)[j]);

    i0 = 1;
    liste_aut2[0] = ch_copy(liste_aut[0]);

    for (i = 1; i < o; i++) {
        iw = 0;
        kw = liste_aut[i];

        for (j = 0; j < i0; j++) {
            if (comp(kw, liste_aut2[j]) == 1) {
                iw = 1;
                break;
            }
        }

        if (iw == 0) {
            ii = 0;

            for (j = 0; j < i0; j++)
                if (est_avantb(kw, liste_aut2[j]) == 1) {
                    ii = 1;
                    break;
                }

            if (ii == 0)
                liste_aut2[i0++] = ch_copy(liste_aut[i]);
            else {
                for (iw = i0 - 1; iw >= j; iw--) {
                    if (iw < i0 - 1)
                        free(liste_aut2[iw + 1]);
                    liste_aut2[iw + 1] = ch_copy(liste_aut2[iw]);
                }

                free(liste_aut2[j]);
                liste_aut2[j] = ch_copy(kw);
                i0++;
            }
        }
    }

    memset(k, 0, i_len);
    sprintf(k, "%s/LIST_AUTH_ARXIV.STR", argv[1]);
    S = fopen(k, "w");
    if (S == NULL) {
        error_mess(flow_interp, 8);
        ind = 1;
        goto end2;
    }
    fprintf(S, "%d\n", i0);
    for (i = 0; i < i0; i++)
        fprintf(S, "%s\n", liste_aut2[i]);
    fclose(S);

    memset(k, 0, i_len);
    sprintf(k, "%s/LIST_AUTH_ARXIV_ART.STR", argv[1]);
    S = fopen(k, "w");
    if (S == NULL) {
        error_mess(flow_interp, 8);
        ind = 1;
        goto end2;
    }
    fprintf(S, "%d\n", i0);

    for (i = 0; i < i0; i++) {
        fprintf(S, "%s%d-%s\n", chk, i, liste_aut2[i]);
        kw = liste_aut2[i];

        for (j = 0; j < nb; j++) {
            ind = 0;
            for (iw = 0; iw < D[j].nb_aut; iw++) {
                if (comp(kw, (D[j].name_aut2)[iw]) == 1) {
                    ind = 1;
                    break;
                }
            }

            if (ind == 1)
                fprintf(S, "%d\n", j);
        }
    }
end2:    fclose(S);
    free(k);
    free(chk);

    for (i = 0; i < o; i++) {
        if (liste_aut[i] != NULL)
            free(liste_aut[i]);
        if (liste_aut2[i] != NULL)
            free(liste_aut2[i]);
    }

    if (o > 0) {
        free(liste_aut);
        free(liste_aut2);
    }
    Dfree(D, nb);
    return 0;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
    Fait la liste ordonnee des auteurs des autres documents
    et des articles correspondant  ces auteurs
--------------------------------------------------------------------*/
int
lst_aut_aut(int argc, char *argv[])
{
    FILE           *S,
                   *lst;
    char          **name,
                  **name_aut,
                  **name_aut2,
                  **name_aut3,
                   *k,
                  **zk0,
                  **zk2,
                  **zk3,
                   *zk4,
                   *chk,
                   *kw;
    int             i,
                    ik1,
                    ik2,
                    i0,
                    i1,
                    j,
                    jj,
                    j2,
                    o,
                    i_len,
                    len,
                    lim,
                   *ind,
                   *nb_aut,
                   *num_art,
                   *num_aut,
                    iz;
    size_t          N;
    flow_data      *flow_interp;

    INIT_FLOW(flow_interp);
    chk = (char *) malloc((size_t) 2 * sizeof(char));
    chk[0] = 35;
    chk[1] = 0;

/*-------------------------------------------------------
    lecture de la liste des articles
-------------------------------------------------------*/
    i_len = 100 + strlen(argv[1]);
    k = (char *) malloc((size_t) i_len * sizeof(char));
    memset(k, 0, i_len);
    sprintf(k, "%s/liste_div.lst", argv[1]);
    lst = NULL;
    lst = fopen(k, "r");
    if (lst == NULL) {
        error_mess(flow_interp, 11);
        free(chk);
        free(k);
        return 1;
    }
    file_param(lst, &lim, &i0, &len);
    lim += 2;
    N = i0 + 2;
    memset(k, 0, i_len);
    zk0 = (char **) malloc((size_t) lim * sizeof(char *));
    name = (char **) malloc((size_t) lim * sizeof(char *));
    memset(zk0, 0, lim * sizeof(char *));
    zk2 = (char **) malloc((size_t) lim * sizeof(char *));
    memset(zk2, 0, lim * sizeof(char *));
    zk3 = (char **) malloc((size_t) lim * sizeof(char *));
    memset(zk3, 0, lim * sizeof(char *));
    zk4 = (char *) malloc((size_t) N * sizeof(char));
    memset(zk4, 0, N);
    zk0[0] = (char *) malloc((size_t) N * sizeof(char));
    memset(zk0[0], 0, N);
    j = 0;

    while (getline(&zk0[j], &N, lst) != -1) {
        name[j] = (char *) malloc((size_t) N * sizeof(char));
        memset(name[j], 0, N);
        if (getline(&name[j], &N, lst) == -1)
            break;
        zk2[j] = (char *) malloc((size_t) N * sizeof(char));
        memset(zk2[j], 0, N);
        if (getline(&zk2[j], &N, lst) == -1)
            break;
        zk3[j] = (char *) malloc((size_t) N * sizeof(char));
        memset(zk3[j], 0, N);
        if (getline(&zk3[j], &N, lst) == -1)
            break;
        ik1 = strlen(name[j]);
        ik2 = strlen(zk2[j]);
        name[j][ik1 - 1] = 0;
        zk2[j][ik2 - 1] = 0;
        memset(zk4, 0, N);
        j++;
        if (getline(&zk4, &N, lst) == -1)
            break;
        zk0[j] = (char *) malloc((size_t) N * sizeof(char));
        memset(zk0[j], 0, N);
    }

    i1 = j;
    fclose(lst);
/*-----------------------------------------------------*/

    nb_aut = (int *) malloc((size_t) (j + 1) * sizeof(int));
    ik2 = 0;

    for (i = 0; i < j; i++) {
        o = strlen(name[i]);

        for (jj = 0; jj < o - 1; jj++) {
            if (name[i][jj] == 32) {
                j2 = jj + 1;
                iz = 0;

                while (name[i][j2] == 32) {
                    j2++;
                    iz++;
                }

                if (iz > 0) {
                    for (j2 = jj + 1; j2 < o - iz; j2++)
                        name[i][j2] = name[i][j2 + iz];
                    for (j2 = o - iz; j2 < o; j2++)
                        name[i][j2] = 0;
                }
            }
        }

        for (jj = 0; jj < o; jj++) {
            if (name[i][jj] != 32)
                break;

            for (j2 = 0; j2 < o - 1; j2++)
                name[i][j2] = name[i][j2 + 1];

            name[i][o - 1] = 0;
            o--;
        }

        for (jj = o - 1; jj >= 0; jj--) {
            if (name[i][jj] != 32)
                break;
            name[i][jj] = 0;
            o--;
        }

        ik1 = 1;
        for (jj = 0; jj < o - 1; jj++)
            if (name[i][jj] == 32)
                ik1++;
        nb_aut[i] = ik1;
        ik2 += ik1;
    }

    name_aut = (char **) malloc((size_t) ik2 * sizeof(char *));
    name_aut2 = (char **) malloc((size_t) ik2 * sizeof(char *));
    num_art = (int *) malloc((size_t) ik2 * sizeof(int));
    num_aut = (int *) malloc((size_t) ik2 * sizeof(int));

    for (i = 0; i < ik2; i++) {
        name_aut[i] = (char *) malloc((size_t) N * sizeof(char));
        memset(name_aut[i], 0, N);
    }

    ik1 = 0;

    for (i = 0; i < j; i++) {
        o = strlen(name[i]);
        iz = 0;

        for (jj = 0; jj < o; jj++) {
            if (name[i][jj] != 32)
                name_aut[ik1][iz++] = name[i][jj];
            else {
                for (j2 = 0; j2 < iz; j2++)
                    if (name_aut[ik1][j2] == 35)
                        name_aut[ik1][j2] = 32;
                iz = 0;
                num_art[ik1] = i;
                ik1++;
            }
        }

        for (j2 = 0; j2 < iz; j2++)
            if (name_aut[ik1][j2] == 35)
                name_aut[ik1][j2] = 32;
        num_art[ik1] = i;
        ik1++;
    }

    iz = 1;
    name_aut2[0] = name_aut[0];
    num_aut[0] = 0;

    for (i = 1; i < ik2; i++) {
        kw = name_aut[i];
        j2 = 0;

        for (jj = 0; jj < iz; jj++) {
            if (comp(kw, name_aut2[jj]) == 1) {
                j2 = 1;
                num_aut[i] = jj;
                break;
            }
        }

        if (j2 == 0) {
            num_aut[i] = iz;
            name_aut2[iz++] = kw;
        }
    }

    name_aut3 = (char **) malloc((size_t) ik2 * sizeof(char *));
    ind = (int *) malloc((size_t) ik2 * sizeof(int));
    ind[0] = 0;
    name_aut3[0] = name_aut2[0];

    for (i = 1; i < iz; i++) {
        kw = name_aut2[i];
        o = 0;

        for (j2 = 0; j2 < i; j2++) {
            if (est_avantb(kw, name_aut3[j2]) == 1) {
                o = 1;

                for (jj = i; jj >= j2 + 1; jj--) {
                    name_aut3[jj] = name_aut3[jj - 1];
                    ind[jj] = ind[jj - 1];
                }

                name_aut3[j2] = kw;
                ind[j2] = i;
                break;
            }
        }

        if (o == 0) {
            name_aut3[i] = kw;
            ind[i] = i;
        }
    }

    memset(k, 0, i_len);
    sprintf(k, "%s/LIST_AUTH_AUT.STR", argv[1]);
    S = fopen(k, "w");
    if (S == NULL) {
        error_mess(flow_interp, 8);
        goto end3;
    }
    fprintf(S, "%d\n", iz);
    for (i = 0; i < iz; i++)
        fprintf(S, "%s\n", name_aut3[i]);

    fclose(S);
    memset(k, 0, i_len);
    sprintf(k, "%s/LIST_AUTH_AUT_ART.STR", argv[1]);
    S = fopen(k, "w");
    if (S == NULL) {
        error_mess(flow_interp, 8);
        goto end3;
    }
    fprintf(S, "%d\n", iz);

    for (i = 0; i < iz; i++) {
        fprintf(S, "%s-%s\n", chk, name_aut3[i]);
        j = 0;
        j2 = ind[i];

        for (jj = 0; jj < ik2; jj++) {
            if (num_aut[jj] == j2)
                fprintf(S, "%d\n", num_art[jj]);
        }
    }

    fclose(S);

end3: for (i = 0; i < ik2; i++)
        free(name_aut[i]);
    for (i = 0; i < j; i++)
        free(name[i]);
    free(name_aut);
    free(name_aut2);
    free(name_aut3);
    free(ind);
    free(nb_aut);
    free(num_art);
    free(num_aut);
    free(chk);

    for (i = 0; i < i1; i++) {
        free(zk0[i]);
        free(name[i]);
        free(zk2[i]);
        free(zk3[i]);
    }

    if (zk0[i1] != NULL)
        free(zk0[i1]);
    free(zk0);
    free(zk2);
    free(zk3);
    free(zk4);
    free(name);
    free(k);
    return 0;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
    Fait la liste ordonnee des auteurs des articles arXiv et des
    autres documents, et des articles correspondant  ces auteurs
--------------------------------------------------------------------*/
int
mix_arxiv_aut(int argc, char *argv[])
{
    FILE           *lst;
    char          **name_arxiv,
                  **fic_aut,
                  **fic_arxiv,
                  **name_aut,
                  **name_tot,
                   *cc,
                   *k,
                   *chk,
                   *kw;
    int             i,
                    i_len,
                    i0,
                    len,
                    lim,
                    j,
                    j2,
                    jmax_aut,
                    jmax_arxiv,
                    nb_aut_arxiv,
                    nb_aut_aut,
                   *ind_aut,
                   *ind_arxiv,
                   *nb_art_aut,
                   *nb_art_arxiv,
                  **ind_art_aut,
                  **ind_art_arxiv,
                    nb,
                    i_arxiv,
                    i_aut,
                    iz;
    size_t          N;
    flow_data      *flow_interp;

    INIT_FLOW(flow_interp);
    chk = (char *) malloc((size_t) 2 * sizeof(char));
    chk[0] = 35;
    chk[1] = 0;
    i_len = 100 + strlen(argv[1]) + strlen(argv[2]);
    k = (char *) malloc((size_t) i_len * sizeof(char));
    memset(k, 0, i_len);
    sprintf(k, "%s/LIST_AUTH_AUT_ART.STR", argv[1]);
    lst = NULL;
    lst = fopen(k, "r");
    if (lst == NULL) {
        error_mess(flow_interp, 11);
        free(chk);
        free(cc);
        free(k);
        return 1;
    }
    file_param(lst, &lim, &i0, &len);
    memset(k, 0, i_len);
    N = i0 + 2;
    lim += 2;
    cc = (char *) malloc((size_t) N * sizeof(char));
    memset(cc, 0, N);
    j = 0;
    fic_aut = (char **) malloc((size_t) lim * sizeof(char *));
    memset(fic_aut, 0, lim * sizeof(char *));

    while (getline(&cc, &N, lst) != -1) {
        fic_aut[j] = ch_copy(cc);
        memset(cc, 0, N);
        j++;
    }

    jmax_aut = j;
    fclose(lst);
    sprintf(k, "%s/LIST_AUTH_ARXIV_ART.STR", argv[1]);
    lst = NULL;
    lst = fopen(k, "r");
    if (lst == NULL) {
        error_mess(flow_interp, 11);
        free(chk);
        free(k);
        return 1;
    }
    memset(k, 0, i_len);
    file_param(lst, &lim, &i0, &len);
    N = i0 + 2;
    lim += 2;
    free(cc);
    cc = (char *) malloc((size_t) N * sizeof(char));
    memset(cc, 0, N);
    j = 0;
    fic_arxiv = (char **) malloc((size_t) lim * sizeof(char *));
    memset(fic_arxiv, 0, lim * sizeof(char *));

    while (getline(&cc, &N, lst) != -1) {
        fic_arxiv[j] = ch_copy(cc);
        memset(cc, 0, N);
        j++;
    }

    jmax_arxiv = j;
    fclose(lst);
    sprintf(k, "%s/LIST_AUTH_AUT.STR", argv[1]);
    lst = NULL;
    lst = fopen(k, "r");
    if (lst == NULL) {
        error_mess(flow_interp, 11);
        free(chk);
        free(k);
        return 1;
    }
    memset(k, 0, i_len);
    file_param(lst, &lim, &i0, &len);
    N = i0 + 2;
    free(cc);
    cc = (char *) malloc((size_t) N * sizeof(char));
    memset(cc, 0, N);
    j = 0;
    fscanf(lst, "%d\n", &nb_aut_aut);
    name_aut = (char **) malloc((size_t) nb_aut_aut * sizeof(char *));
    memset(name_aut, 0, nb_aut_aut * sizeof(char *));

    for (j = 0; j < nb_aut_aut; j++) {
        if (getline(&cc, &N, lst) != -1) {
            iz = strlen(cc) - 1;
            cc[iz] = 0;
            name_aut[j] = ch_copy(cc);
            memset(cc, 0, N);
        }
        else { /* erreur */
            STR_exit(1);
        }
    }

    fclose(lst);
    sprintf(k, "%s/LIST_AUTH_ARXIV.STR", argv[1]);
    lst = NULL;
    lst = fopen(k, "r");
    if (lst == NULL) {
        error_mess(flow_interp, 11);
        free(chk);
        free(k);
        return 1;
    }
    memset(k, 0, i_len);
    file_param(lst, &lim, &i0, &len);
    N = i0 + 2;
    free(cc);
    cc = (char *) malloc((size_t) N * sizeof(char));
    memset(cc, 0, N);
    j = 0;
    fscanf(lst, "%d\n", &nb_aut_arxiv);
    name_arxiv = (char **) malloc((size_t) nb_aut_arxiv * sizeof(char *));
    memset(name_arxiv, 0, nb_aut_arxiv * sizeof(char *));

    for (j = 0; j < nb_aut_arxiv; j++) {
        if (getline(&cc, &N, lst) != -1) {
            iz = strlen(cc) - 1;
            cc[iz] = 0;
            name_arxiv[j] = ch_copy(cc);
            memset(cc, 0, N);
        }
        else { /* erreur */
            STR_exit(2);
        }
    }

    fclose(lst);
    nb = nb_aut_arxiv + nb_aut_aut;
    ind_aut = (int *) malloc((size_t) nb * sizeof(int));
    ind_arxiv = (int *) malloc((size_t) nb * sizeof(int));
    name_tot = (char **) malloc((size_t) nb * sizeof(char *));

    for (i = 0; i < nb; i++) {
        ind_aut[i] = -1;
        ind_arxiv[i] = -1;
    }

    nb = nb_aut_arxiv;

    for (i = 0; i < nb_aut_arxiv; i++) {
        name_tot[i] = name_arxiv[i];
        ind_arxiv[i] = i;
    }

    for (i = 0; i < nb_aut_aut; i++) {
        kw = name_aut[i];
        iz = 0;

        for (j = 0; j < nb; j++) {
            if (comp(kw, name_tot[j]) == 1) {
                ind_aut[j] = i;
                iz = 1;
                break;
            }
            if (est_avantb(kw, name_tot[j]) == 1) {
                iz = 1;

                for (j2 = nb; j2 > j; j2--) {
                    name_tot[j2] = name_tot[j2 - 1];
                    ind_aut[j2] = ind_aut[j2 - 1];
                    ind_arxiv[j2] = ind_arxiv[j2 - 1];
                }
                name_tot[j] = kw;
                ind_aut[j] = i;
                ind_arxiv[j] = -1;
                nb++;
                break;
            }
        }

        if (iz == 0) {
            name_tot[nb] = kw;
            ind_aut[nb] = i;
            ind_arxiv[nb] = -1;
            nb++;
        }
    }

    memset(k, 0, i_len);
    sprintf(k, "%s/LIST_AUTH_MIX.STR", argv[1]);
    lst = NULL;
    lst = fopen(k, "w");
    if (lst == NULL) {
        error_mess(flow_interp, 11);
        free(chk);
        free(k);
        return 1;
    }
    fprintf(lst, "%d\n", nb);

    for (i = 0; i < nb; i++) {
        fprintf(lst, "%s\n", name_tot[i]);
        fprintf(lst, "%d\n", ind_arxiv[i]);
        fprintf(lst, "%d\n", ind_aut[i]);
    }

    fclose(lst);
    memset(k, 0, i_len);
    nb_art_aut = (int *) malloc((size_t) nb_aut_aut * sizeof(int));
    ind_art_aut = (int **) malloc((size_t) nb_aut_aut * sizeof(int *));
    for (j = 0; j <  nb_aut_aut; j++)
        nb_art_aut[j] = 0;
    j = -1;
    j2 = 0;

    for (i = 1; i < jmax_aut; i++) {
        if (fic_aut[i][0] == 35)
            j++;
        else
            nb_art_aut[j]++;
    }

    for (j = 0; j <  nb_aut_aut; j++) {
        ind_art_aut[j] = (int *) malloc((size_t) (nb_art_aut[j] + 1) *
            sizeof(int));
        for (i = 0; i <= nb_art_aut[j]; i++)
            ind_art_aut[j][i] = 0;
    }

    j = -1;

    for (i = 1; i < jmax_aut; i++) {
        if (fic_aut[i][0] == 35) {
            j++;
            j2 = 0;
        }
        else
            ind_art_aut[j][j2++] = (int) strtol((const char *) fic_aut[i],
                NULL, 10);
    }

    nb_art_arxiv = (int *) malloc((size_t) nb_aut_arxiv * sizeof(int));
    ind_art_arxiv = (int **) malloc((size_t) nb_aut_arxiv * sizeof(int *));
    for (j = 0; j <  nb_aut_arxiv; j++)
        nb_art_arxiv[j] = 0;
    j = -1;

    for (i = 1; i < jmax_arxiv; i++) {
        if (fic_arxiv[i][0] == 35)
            j++;
        else
            nb_art_arxiv[j]++;
    }

    for (j = 0; j <  nb_aut_arxiv; j++) {
        ind_art_arxiv[j] = (int *) malloc((size_t) (nb_art_arxiv[j] + 1) *
            sizeof(int));
        for (i = 0; i <= nb_art_arxiv[j]; i++)
            ind_art_arxiv[j][i] = 0;
    }

    j = -1;

    for (i = 1; i < jmax_arxiv; i++) {
        if (fic_arxiv[i][0] == 35) {
            j++;
            j2 = 0;
        }
        else
            ind_art_arxiv[j][j2++] = (int) strtol((const char *) fic_arxiv[i],
                NULL, 10);
    }

    sprintf(k, "%s/LIST_AUTH_ART.STR", argv[1]);
    lst = NULL;
    lst = fopen(k, "w");
    if (lst == NULL) {
        error_mess(flow_interp, 11);
        free(chk);
        free(k);
        return 1;
    }
    i_arxiv = 0;
    i_aut = 0;

    for (j = 0; j < nb; j++) {
        kw = name_tot[j];
        fprintf(lst, "#-%s\n", kw);
        if (ind_arxiv[j] >= 0)
            fprintf(lst, "%d\n", nb_art_arxiv[ind_arxiv[j]]);
        else
            fprintf(lst, "0\n");
        if (ind_aut[j] >= 0)
            fprintf(lst, "%d\n", nb_art_aut[ind_aut[j]]);
        else
            fprintf(lst, "0\n");
        fprintf(lst, "-----\n");
        if (ind_arxiv[j] >= 0) {
            for (i = 0; i < nb_art_arxiv[ind_arxiv[j]]; i++)
                fprintf(lst, "%d\n", ind_art_arxiv[i_arxiv][i]);
            i_arxiv++;
        }
        fprintf(lst, "-----\n");
        if (ind_aut[j] >= 0) {
            for (i = 0; i < nb_art_aut[ind_aut[j]]; i++)
                fprintf(lst, "%d\n", ind_art_aut[i_aut][i]);
            i_aut++;
        }
    }

    fclose(lst);
    memset(k, 0, i_len);

    sprintf(k, "%s/LIST_AUTH_MIX0.STR", argv[1]);
    lst = NULL;
    lst = fopen(k, "w");
    if (lst == NULL) {
        error_mess(flow_interp, 11);
        free(chk);
        free(k);
        return 1;
    }
    fprintf(lst, "%d\n", nb);

    for (i = 0; i < nb; i++)
        fprintf(lst, "%s\n", name_tot[i]);

    fclose(lst);

    free(chk);
    free(cc);
    free(k);
    for (i = 0; i < jmax_aut; i++)
        free(fic_aut[i]);
    for (i = 0; i < jmax_arxiv; i++)
        free(fic_arxiv[i]);
    for (i = 0; i < nb_aut_aut; i++)
        free(name_aut[i]);
    for (i = 0; i < nb_aut_arxiv; i++)
        free(name_arxiv[i]);
    free(name_aut);
    free(name_arxiv);
    free(fic_aut);
    free(fic_arxiv);
    free(name_tot);
    free(ind_aut);
    free(ind_arxiv);
    free(nb_art_arxiv);
    free(nb_art_aut);
    for (j = 0; j <  nb_aut_aut; j++)
        free(ind_art_aut[j]);
    for (j = 0; j <  nb_aut_arxiv; j++)
        free(ind_art_arxiv[j]);
    free(ind_art_aut);
    free(ind_art_arxiv);
    return 0;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
    Creation des fichiers html correspondant  tous les auteurs
--------------------------------------------------------------------*/
int
make_html2(int argc, char *argv[])
{
    int             i,
                    j,
                    jj,
                    j2,
                    nb,
                    lim,
                    o,
                    ii,
                    ik1,
                    ik2,
                    i0,
                    ind[26],
                    iw,
                    iw1,
                    i_len,
                    i_al,
                    ind_al,
                   *ind_deb,
                   *ind_fin,
                    i1,
                    i2,
                    i3,
                    i4,
                    i5,
                  **iz,
                  **izw,
                   *izw2,
                   *izw3,
                    izw0,
                   *iwk,
                    indx,
                    indy,
                   *ind_a,
                   *i_auth,
                    len,
                   *nb_aut,
                    nb_aut2,
                    nb_aut3,
                    nb_arxiv2,
                    nb_arxiv3,
                   *nb_arxiv,
                  **ind_aut,
                   *ind_aut2,
                  **ind_arxiv,
                   *ind_arxiv2;
    char            ch1,
                  **name,
                  **name_a,
                 ***name_b,
                  **name_c,
                 ***name_alX,
                  **fic,
                  **fic2,
                   *k0,
                   *kw,
                   *k,
                  **zk0,
                  **zk2,
                  **zk3,
                   *zk4,
                   *chk,
                    ch0;
    math_rec       *D;
    flow_data      *flow_interp;
    size_t          N;
    FILE           *S;

    INIT_FLOW(flow_interp);
    j = 0;
    i4 = -1;
    i5 = 0;
    name_c = NULL;
    name_alX = NULL;
    ind_deb = NULL;
    ind_fin = NULL;
    ind_aut2 = NULL;
    ind_arxiv2 = NULL;
    ind_a = NULL;
    iwk = NULL;
    i_auth = NULL;
    nb_aut = NULL;
    nb_arxiv = NULL;
    ind_aut = NULL;
    ind_arxiv = NULL;
    name_a = NULL;
    name_b = NULL;
    lim = 0;
    chk = (char *) malloc((size_t) 2 * sizeof(char));
    chk[1] = 0;
    i_len = strlen(argv[1]);
    i0 = strlen(argv[2]);
    if (i0 > i_len)
        i_len = i0;
    i_len += 100;
    k = (char *) malloc((size_t) i_len * sizeof(char));

/*-------------------------------------------------------
    lecture de la liste des articles arXiv
-------------------------------------------------------*/
    memset(k, 0, i_len);
    sprintf(k, "%s/DB.STR", argv[1]);
    S = fopen(k, "r");
    if (S == NULL) {
        error_mess(flow_interp, 8);
        goto end5;
    }
    nb = 0;
    fscanf(S, "%d", &nb);
    if (nb <= 0) {
        error_mess(flow_interp, 10);
        fclose(S);
        goto end5;
    }
    fread(&ch1, 1, 1, S);
    D = (math_rec *) malloc((size_t) nb * sizeof(math_rec));
    Dzero(D, nb);
    for (i = 0; i < nb; i++)
        lec_DB_STR(S, &D[i]);
    fclose(S);
/*-----------------------------------------------------*/

    memset(k, 0, i_len);

/*-------------------------------------------------------
    lecture de la liste des autres articles
-------------------------------------------------------*/
    sprintf(k, "%s/liste_div.lst", argv[1]);
    S = NULL;
    S = fopen(k, "r");
    if (S == NULL) {
        error_mess(flow_interp, 11);
        return 1;
    }
    memset(k, 0, i_len);
    file_param(S, &lim, &i0, &len);
    lim += 2;
    zk0 = (char **) malloc((size_t) lim * sizeof(char *));
    name = (char **) malloc((size_t) lim * sizeof(char *));
    memset(zk0, 0, lim * sizeof(char *));
    zk2 = (char **) malloc((size_t) lim * sizeof(char *));
    memset(zk2, 0, lim * sizeof(char *));
    zk3 = (char **) malloc((size_t) lim * sizeof(char *));
    memset(zk3, 0, lim * sizeof(char *));
    N = i0 + 2;
    zk4 = (char *) malloc((size_t) N * sizeof(char));
    memset(zk4, 0, N);
    zk0[0] = (char *) malloc((size_t) N * sizeof(char));
    memset(zk0[0], 0, N);
    j = 0;

    while (getline(&zk0[j], &N, S) != -1) {
        name[j] = (char *) malloc((size_t) N * sizeof(char));
        memset(name[j], 0, N);
        if (getline(&name[j], &N, S) == -1)
            break;
        zk2[j] = (char *) malloc((size_t) N * sizeof(char));
        memset(zk2[j], 0, N);
        if (getline(&zk2[j], &N, S) == -1)
            break;
        zk3[j] = (char *) malloc((size_t) N * sizeof(char));
        memset(zk3[j], 0, N);
        if (getline(&zk3[j], &N, S) == -1)
            break;
        ik1 = strlen(name[j]);
        ik2 = strlen(zk2[j]);
        name[j][ik1 - 1] = 0;
        zk2[j][ik2 - 1] = 0;
        memset(zk4, 0, N);
        j++;
        if (getline(&zk4, &N, S) == -1)
            break;
        zk0[j] = (char *) malloc((size_t) N * sizeof(char));
        memset(zk0[j], 0, N);
    }

    fclose(S);
/*-----------------------------------------------------*/

    for (i = 0; i < j; i++) {
        j2 = strlen(name[i]);
        for (ii = 0; ii < j2; ii++)
            if (name[i][ii] == 35)
                name[i][ii] = 32;
    }

    iz = (int **) malloc((size_t) 26 * sizeof(int *));
    izw = (int **) malloc((size_t) 26 * sizeof(int *));

    for (i = 0; i < 26; i++) {
        iz[i] = (int *) malloc((size_t) lim * sizeof(int));
        izw[i] = (int *) malloc((size_t) lim * sizeof(int));
    }

    name_b = (char ***) malloc((size_t) 26 * sizeof(char **));
    izw2 = (int *) malloc((size_t) lim * sizeof(int));
    izw3 = (int *) malloc((size_t) lim * sizeof(int));

    for (i0 = 0; i0 < 26; i0++)
        name_b[i0] = (char **) malloc((size_t) lim * sizeof(char *));

    for (i0 = 0; i0 < 26; i0++)
        ind[i0] = 0;

    for (i = 0; i < j; i++) {
        i0 = name[i][0] - 65;
        if (i0 >= 0 && i0 < 26) {
            iz[i0][ind[i0]] = i;
            ind[i0]++;
        }
    }

    for (i0 = 0; i0 < 26; i0++) {
        for (jj = 0; jj < ind[i0]; jj++) {
            ik1 = iz[i0][jj];
            name_b[i0][jj] = name[ik1];
            izw[i0][jj] = ik1;
        }

        for (jj = 0; jj < ind[i0]; jj++) {
            ik1 = 0;
            for (j2 = 0; j2 < ind[i0] - 1; j2++)
                if (est_avantb(name_b[i0][j2 + 1], name_b[i0][j2]) == 1)
                    ik1 = 1;
            if (ik1 == 1) {
                for (j2 = 0; j2 < ind[i0]; j2++)
                    for (ik2 = j2 + 1; ik2 < ind[i0]; ik2++)
                        if (est_avantb(name_b[i0][ik2], name_b[i0][j2]) == 1) {
                            echange_nom_b(&name_b[i0][j2], &name_b[i0][ik2]);
                            izw0 = izw[i0][j2];
                            izw[i0][j2] = izw[i0][ik2];
                            izw[i0][ik2] = izw0;
                        }
                }
        }
    }

    i = 0;

    for (i0 = 0; i0 < 26; i0++) {
        for (ii = 0; ii < ind[i0]; ii++) {
            izw2[i++] = izw[i0][ii];
        }
    }

    for (i0 = 0; i0 < j; i0++) {
        for (ii = 0; ii < j; ii++) {
            if (izw2[ii] == i0) {
                izw3[i0] = ii;
                break;
            }
        }
    }

    sprintf(k, "%s/LIST_AUT_INV.STR", argv[1]);
    S = NULL;
    S = fopen(k, "w");
    if (S == NULL) {
        error_mess(flow_interp, 11);
        free(chk);
        free(izw2);
        free(izw3);
        return 1;
    }
    fprintf(S, "%d\n", j);
    for (i = 0; i < j; i++)
        fprintf(S, "%d\n", izw3[i]);
    fclose(S);
    memset(k, 0, i_len);


/*-------------------------------------------------------
    lecture des listes d'auteurs
-------------------------------------------------------*/
    sprintf(k, "%s/LIST_AUTH_ART.STR", argv[1]);
    S = NULL;
    S = fopen(k, "r");
    if (S == NULL) {
        error_mess(flow_interp, 11);
        free(chk);
        free(izw2);
        free(izw3);
        return 1;
    }
    lit_file(S, &fic, &ii, &j2, 0);

    i5 = ii;
    memset(k, 0, i_len);
    fclose(S);
    sprintf(k, "%s/LIST_AUTH_MIX0.STR", argv[1]);
    S = NULL;
    S = fopen(k, "r");
    if (S == NULL) {
        error_mess(flow_interp, 11);
        free(chk);
        free(izw2);
        free(izw3);
        return 1;
    }
    file_param(S, &j2, &i0, &len);
    i0 += 2;
    fscanf(S, "%d\n", &o);
    name_a = (char **) malloc((size_t) o * sizeof(char *));
    ind_a = (int *) malloc((size_t) o * sizeof(int));
    k0 = (char *) malloc((size_t) i0 * sizeof(char));

    for (i = 0; i < o; i++) {
        ind_a[i] = 1;
        getline(&k0, &N, S);
        k0[strlen(k0) - 1] = 0;
        name_a[i] = ch_copy(k0);
        memset(k0, 0, i0);
    }

    i_auth = NULL;
    if (argc > 3) {
        i_auth = (int *) malloc((size_t)(argc -3) * sizeof(int));

        for (i = 0; i < argc -3; i++) {
            i_auth[i] = -1;
            kw = argv[3 + i];

            for (j2 = 0; j2 < j; j2++) {
                if (comp(name_a[j2], kw) == 1) {
                    i_auth[i] = j2;
                    break;
                }
            }
        }
    }

    memset(k, 0, i_len);
    fclose(S);

    nb_arxiv = (int *) malloc((size_t) o * sizeof(int));
    nb_aut = (int *) malloc((size_t) o * sizeof(int));
    ind_arxiv = (int **) malloc((size_t) o * sizeof(int *));
    ind_aut = (int **) malloc((size_t) o * sizeof(int *));

    i0 = 0;
    i = 1;

    while (i < ii) {
        nb_arxiv[i0] = strtol(fic[i++], NULL, 10);
        nb_aut[i0] = strtol(fic[i++], NULL, 10);
        if (nb_arxiv[i0] > 0)
            ind_arxiv[i0] = (int *) malloc((size_t) nb_arxiv[i0] * sizeof(int));
        else
            ind_arxiv[i0] = NULL;
        if (nb_aut[i0] > 0)
            ind_aut[i0] = (int *) malloc((size_t) nb_aut[i0] * sizeof(int));
        else
            ind_aut[i0] = NULL;
        i++;
        for (iw = 0; iw < nb_arxiv[i0]; iw++)
            ind_arxiv[i0][iw] = strtol(fic[i++], NULL, 10);
        i++;
        for (iw = 0; iw < nb_aut[i0]; iw++)
            ind_aut[i0][iw] = strtol(fic[i++], NULL, 10);
        i++;
        i0++;
        /*printf("%d %d - ", i0, i);*/
    }
/*-----------------------------------------------------*/


/*-------------------------------------------------------
    traitement des alias
-------------------------------------------------------*/
    sprintf(k, "%s/alias.lst", argv[1]);
    S = NULL;
    S = fopen(k, "r");
    fic2 = NULL;
    name_c = NULL;
    name_alX = NULL;
    ind_deb = NULL;
    ind_fin = NULL;
    ind_aut2 = (int *) malloc((size_t) i5 * sizeof(int));
    ind_arxiv2 = (int *) malloc((size_t) i5 * sizeof(int));
    i4 = -1;

    if (S != NULL) {
        lit_file(S, &fic2, &ii, &j2, 1);

        i4 = ii;
        name_c = (char **) malloc((size_t)(ii + 1) * sizeof(char *));
        ind_deb = (int *) malloc((size_t)(ii + 1) * sizeof(int));
        ind_fin = (int *) malloc((size_t)(ii + 1) * sizeof(int));
        i_al = 0;
        ind_al = 0;
        i = 0;

        while (i < ii) {
            if (i_al == 0) {
                ind_deb[ind_al] = i;
                name_c[ind_al++] = fic2[i];
                i_al = 1;
            }
            if (fic2[i][0] == 35) {
                i_al = 0;
                if (ind_al > 0)
                    ind_fin[ind_al - 1] = i;
            }
            i++;
        }

        if (ind_al > 0)
            ind_fin[ind_al - 1] = ii;

        if (ind_al > 0) {
            name_alX = (char ***) malloc((size_t) (ii + 1) * sizeof(char **));
            for (j2 = 0; j2 <= ii; j2++)
                name_alX[j2] = (char **) malloc((size_t) ii * sizeof(char *));
            for (j2 = 0; j2 < ind_al; j2++)
                for (i0 = 0; i0 < ind_fin[j2] - ind_deb[j2] - 1; i0++)
                    name_alX[j2][i0] = fic2[ind_deb[j2] + i0 + 1];
        }

        for (i0 = 0; i0 < o; i0++) {
            for (j2 = 0; j2 < ind_al; j2++) {
                if (comp(name_a[i0], name_c[j2]) == 1) {
                    nb_aut2 = nb_aut[i0];
                    nb_arxiv2 = nb_arxiv[i0];
                    for (i3 = 0; i3 < nb_aut2; i3++)
                        ind_aut2[i3] = ind_aut[i0][i3];
                    for (i3 = 0; i3 < nb_arxiv2; i3++)
                        ind_arxiv2[i3] = ind_arxiv[i0][i3];

                    for (i1 = 0; i1 < ind_fin[j2] - ind_deb[j2] - 1; i1++) {
                        for (i2 = 0; i2 < o; i2++) {
                            if (comp(name_a[i2], name_alX[j2][i1]) == 1) {
                                ind_a[i2] = 0;
                                nb_aut3 = nb_aut2 + nb_aut[i2];
                                nb_arxiv3 = nb_arxiv2 + nb_arxiv[i2];
                                for (i3 = nb_aut2; i3 < nb_aut3; i3++)
                                    ind_aut2[i3] = ind_aut[i2][i3 - nb_aut2];
                                nb_aut2 = nb_aut3;
                                for (i3 = nb_arxiv2; i3 < nb_arxiv3; i3++)
                                    ind_arxiv2[i3] = ind_arxiv[i2]
                                        [i3 - nb_arxiv2];
                                nb_arxiv2 = nb_arxiv3;
                                break;
                            }
                        }
                    }

                    nb_aut[i0] = nb_aut2;
                    nb_arxiv[i0] = nb_arxiv2;

                    for (i1 = 0; i1 < nb_aut2; i1++) {
                        i3 = ind_aut2[i1];

                        for (i2 = i1 + 1; i2 < nb_aut2; i2++) {
                            if (ind_aut2[i2] < i3) {
                                ind_aut2[i1] = ind_aut2[i2];
                                ind_aut2[i2] = i3;
                                i3 = ind_aut2[i1];
                            }
                        }
                    }

                    if (ind_aut[i0] != NULL)
                        free(ind_aut[i0]);
                    ind_aut[i0] = (int *) malloc((size_t) nb_aut2 *
                        sizeof(int));
                    for (i1 = 0; i1 < nb_aut2; i1++)
                        ind_aut[i0][i1] = ind_aut2[i1];

                    for (i1 = 0; i1 < nb_arxiv2; i1++) {
                        i3 = ind_arxiv2[i1];

                        for (i2 = i1 + 1; i2 < nb_arxiv2; i2++) {
                            if (ind_arxiv2[i2] < i3) {
                                ind_arxiv2[i1] = ind_arxiv2[i2];
                                ind_arxiv2[i2] = i3;
                                i3 = ind_arxiv2[i1];
                            }
                        }
                    }

                    if (ind_arxiv[i0] != NULL)
                        free(ind_arxiv[i0]);
                    ind_arxiv[i0] = (int *) malloc((size_t) nb_arxiv2 *
                        sizeof(int));
                    for (i1 = 0; i1 < nb_arxiv2; i1++)
                        ind_arxiv[i0][i1] = ind_arxiv2[i1];
                }
            }
        }
        fclose(S);
    }
/*-----------------------------------------------------*/



/*-------------------------------------------------------
    Ecriture de la liste html des auteurs
-------------------------------------------------------*/
    sprintf(k,"%s/0123Auth.html", argv[2]);
    S = fopen(k, "w");
    ch0 = 64;
    for (i = 0; i < 7; i++)
        fprintf(S, "%s\n", Squel[i]);
    fwrite_html_0(60, S);
    fwrite_html_0(47, S);
    fwrite_html_0(65, S);
    fwrite_html_0(62, S);
    _fontsize_html_0(3, S);

    for (i0 = 0; i0 < 26; i0++) {
        if (i0 == 13)
            _br_html_0(S);
        _HREF_deb_html_0(S);
        fwrite_html_0(35, S);
        fwrite_html_0(65 + i0, S);
        _HREF_fin_html_0(S);
        fwrite_html_0(65 + i0, S);
        _invA_html_0(S);
        _nbsp_html_0(S);
        _nbsp_html_0(S);
        _nbsp_html_0(S);
        _nbsp_html_0(S);
    }

    _line_100_html_0(S);
    _fontsize_html_0(2, S);

    for (i = 0; i < o; i++) {
        if (ind_a[i] == 1) {
            if (ch0 < name_a[i][0]) {
                chk[0] = ++ch0;
                _br_html_0(S);
                _line_100_html_0(S);
                _link_html_0(chk, chk, S);
                _line_100_html_0(S);
            }
            memset(k, 0, i_len);
            sprintf(k, "%s/%s.html", argv[2], name_a[i]);
            _HREF_deb_html_0(S);
            fwrite_STR_html_0(k, S);
            _HREF_fin_html_0(S);
            fwrite_STR_html_0(name_a[i], S);
            _br_html_0(S);
        }
    }
/*-----------------------------------------------------*/


    memset(k, 0, i_len);
    fclose(S);


/*--------------------------------------------------------
    Ecriture des fichiers html des auteurs
--------------------------------------------------------*/
    indx = 0;
    iwk = (int *) malloc((size_t) lim * sizeof(int));
    for (ii = 0; ii < lim; ii++)
        iwk[ii] = 0;

    for (i = 0; i < o; i++) {
        indy = 0;
        if (argc > 3) {
            indy = 1;

            for (j2 = 0; j2 < argc - 3; j2++) {
                if (i == i_auth[j2]) {
                    indy = 0;
                    break;
                }
            }
        }

        if (indy == 0 && ind_a[i] == 1) {
            memset(k, 0, i_len);
            sprintf(k, "%s/%s.html", argv[2], name_a[i]);
            S = NULL;
            S = fopen(k, "w");
            if (S == NULL) {
                error_mess(flow_interp, 11);
                free(chk);
                return 1;
            }

            iw1 = -1;

            for (i0 = 0; i0 < nb_arxiv[i]; i0++) {
                iw = ind_arxiv[i][i0];
                if (iw > iw1) {
                    _br_html_0(S);
                    fprintf(S, "%d\n", iw + 1);
                    _br_html_0(S);
                    _B_html_0(S);
                    _color_html_0(S, 60, 60, 240);
                    _big_html_0(S);

                    for (ii = 0; ii < D[iw].nb_aut; ii++) {
                        fprintf(S, "%s\n", D[iw].name_aut[ii]);
                        _br_html_0(S);
                    }

                    _invbig_html_0(S);
                    _invspan_html_0(S);
                    _invB_html_0(S);
                    _italic_html_0(S);
                    fprintf(S, "%s\n", D[iw].titre);
                    _invspan_html_0(S);
                    _br_html_0(S);
                    _br_html_0(S);
                    fprintf(S, "%s\n", D[iw].resume);
                    _br_html_0(S);
                    _br_html_0(S);
                    _line_75_html_0(S);
                    iw1 = iw;
			    }
            }

            if (nb_arxiv[i] > 0)
                _br_html_0(S);
            _line_100_html_0(S);
            _line_100_html_0(S);
            for (i0 = 0; i0 < indx; i0++)
                iwk[i0] = 0;
            indx = nb_aut[i];
            for (i0 = 0; i0 < indx; i0++)
                iwk[i0] = ind_aut[i][i0];

            for (i0 = 0; i0 < indx - 1; i0++) {
                for (ii = i0 + 1; ii < indx; ii++) {
                    if (izw3[iwk[ii]] < izw3[iwk[i0]]) {
                        izw0 = iwk[ii];
                        iwk[ii] = iwk[i0];
                        iwk[i0] = izw0;
                    }
                }
            }

            iw1 = -1;
 
            for (i0 = 0; i0 < nb_aut[i]; i0++) {
				iw = izw3[iwk[i0]];
				if (iw > iw1) {
                    _br_html_0(S);
                    _color_html_0(S, 60, 60, 240);
                    _big_html_0(S);
                    memset(k, 0, i_len);
                    sprintf(k, "%d - %s ", izw3[iwk[i0]] + 1, name[iwk[i0]]);
                    _string_html_0(k, S);
                    _invbig_html_0(S);
                    _invspan_html_0(S);
                    _nbsp_html_0(S);
                    _nbsp_html_0(S);
                    _nbsp_html_0(S);
                    _nbsp_html_0(S);
                    _italic_html_0(S);
                    _string_html_0(zk2[iwk[i0]], S);
                    _invspan_html_0(S);
                    _br_html_0(S);
                    iw1 = iw;
			    }
            }

            _br_html_0(S);
            _br_html_0(S);

            fclose(S);
        }
    }
/*-----------------------------------------------------*/

end5 : free(k);
    free(chk);
    free(k0);

    for (i = 0; i < j; i++) {
        free(zk0[i]);
        free(name[i]);
        free(zk2[i]);
        free(zk3[i]);
    }

    if (zk0[j] != NULL)
        free(zk0[j]);
    if (zk0 != NULL)
        free(zk0);
    if (zk2 != NULL)
        free(zk2);
    if (zk3 != NULL)
        free(zk3);
    if (zk4 != NULL)
        free(zk4);
    if (name != NULL)
        free(name);
    for (i = 0; i < i5; i++)
        free(fic[i]);
    if (fic != NULL)
        free(fic);
    for (i = 0; i < o; i++)
        free(name_a[i]);
    if (name_a != NULL)
        free(name_a);

    for (i = 0; i < o; i++) {
        if (nb_arxiv[i] > 0)
            free(ind_arxiv[i]);
        if (nb_aut[i] > 0)
            free(ind_aut[i]);
    }

    if (lim > 0) {
        for (i0 = 0; i0 < 26; i0++) {
            free(name_b[i0]);
            free(iz[i0]);
            free(izw[i0]);
        }

        if (name_b != NULL)
            free(name_b);
        if (iz != NULL)
            free(iz);
        free(izw);
        free(izw2);
        free(izw3);
    }

    if (iwk != NULL)
        free(iwk);
    if (i_auth != NULL)
        free(i_auth);
    if (name_c != NULL)
        free(name_c);
    if (ind_deb != NULL)
        free(ind_deb);
    if (name_alX != NULL) {
        for (j2 = 0; j2 <= i4; j2++)
            free(name_alX[j2]);
        free(name_alX);
    }
    if (ind_fin != NULL)
        free(ind_fin);
    if (ind_aut2 != NULL)
        free(ind_aut2);
    if (ind_arxiv2 != NULL)
        free(ind_arxiv2);
    if (fic2 != NULL) {
        for (i = 0; i < i4; i++)
            free(fic2[i]);
        free(fic2);
    }
    if (ind_arxiv != NULL)
        free(ind_arxiv);
    if (ind_aut != NULL)
        free(ind_aut);
    if (nb_arxiv != NULL)
        free(nb_arxiv);
    if (nb_aut != NULL)
        free(nb_aut);
    if (ind_a != NULL)
        free(ind_a);
    Dfree(D, nb);
    return 0;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------

--------------------------------------------------------------------*/
int
init_dir(int argc, char *argv[])
{
    int             i0,
                    l,
                    len,
                    lin,
                    line_s;
    char           *init_file,
                   *init_file2,
                   *init_file3,
                   *init_file0,
                   *base_dir,
                   *base_dir2,
                   *kk[4];
    flow_data      *flow_interp;
    FILE           *init;

    INIT_FLOW(flow_interp);
    init_file = ch_copy(".listerc3");
    init_file0 = ch_copy(".listrc/.listerc3");
    init_file2 = NULL;
    init_file3 = NULL;
    l = strlen(getenv("HOME")) + strlen(init_file0) + 10;
    init_file3 = (char *) malloc((size_t) l * sizeof(char));
    memset(init_file3, 0, l);
    sprintf(init_file3, "%s/%s", getenv("HOME"), init_file0);
    init = fopen(init_file3, "r");
    if (init == NULL) {
                free(init_file3);
                init_file3 = NULL;
        l = strlen(getenv("HOME")) + strlen(init_file) + 10;
        init_file2 = (char *) malloc((size_t) l * sizeof(char));
        memset(init_file2, 0, l);
        sprintf(init_file2, "%s/%s", getenv("HOME"), init_file);
        init = fopen(init_file2, "r");
        if (init == NULL) {
            error_mess(flow_interp, 12);
            STR_exit(3);
            return 1;
        }
    }
    file_param(init, &lin, &line_s, &len);
    line_s += 2;
    base_dir = (char *) malloc((size_t) line_s * sizeof(char *));
    base_dir2 = (char *) malloc((size_t) line_s * sizeof(char *));
    memset(base_dir, 0, line_s);
    memset(base_dir2, 0, line_s);
    if (fscanf(init, "%s", base_dir) != 1) {
        error_mess(flow_interp, 13);
        free(base_dir);
        free(base_dir2);
        STR_exit(4);
        return 1;
    }
    if (fscanf(init, "%s", base_dir2) != 1) {
        error_mess(flow_interp, 13);
        free(base_dir);
        free(base_dir2);
        STR_exit(5);
        return 1;
    }
    kk[0] = (char *) flow_interp;
    kk[1] = ch_copy("string");
    kk[2] = ch_copy("dirDB");
    kk[3] = ch_copy(base_dir);
    i0 = setstring_cmd(3, kk + 1);
    free(kk[2]);
    free(kk[3]);
    if (i0 == -1) {
        error_mess(flow_interp, 14);
        STR_exit(0);
    }
    kk[2] = ch_copy("dirData");
    kk[3] = ch_copy(base_dir2);
    i0 = setstring_cmd(3, kk + 1);
    free(kk[2]);
    free(kk[3]);
    if (i0 == -1) {
        error_mess(flow_interp, 14);
        STR_exit(0);
    }
    if (init_file2 != NULL)
        free(init_file2);
    if (init_file3 != NULL)
        free(init_file3);
    free(init_file);
    free(init_file0);
    return 0;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------

--------------------------------------------------------------------*/
int
find_dup(int argc, char *argv[])
{
    int             i,
                    j,
                    nb,
                    ind,
                    i_len;
    char            ch1,
                   *k0,
                   *k;
    math_rec       *D;
    flow_data      *flow_interp;
    FILE           *S;

    INIT_FLOW(flow_interp);
    i_len = 100 + strlen(argv[1]);
    k = (char *) malloc((size_t) i_len * sizeof(char));
    sprintf(k, "%s/DB.STR", argv[1]);
    S = fopen(k, "r");
    if (S == NULL) {
        error_mess(flow_interp, 8);
        ind = 1;
        goto end;
    }
    nb = 0;
    fscanf(S, "%d", &nb);
    if (nb <= 0) {
        error_mess(flow_interp, 10);
        ind = 1;
        goto end;
    }
    fread(&ch1, 1, 1, S);
    D = (math_rec *) malloc((size_t) nb * sizeof(math_rec));
    Dzero(D,nb);
    for (i = 0; i < nb; i++) {
        lec_DB_STR(S, &D[i]);
        nettoie_x(D[i].titre);
    }

    for (i = 0; i < nb - 1; i++) {
        k0 = D[i].titre;

        for (j = i + 1; j < nb; j++) {
            if (comp(k0, D[j].titre) == 1)
                printf("%s %s\n", D[i].ref, D[j].ref);
        }
    }

end:  fclose(S);
    free(k);
    return 0;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------

--------------------------------------------------------------------*/
int
find_dup2(int argc, char *argv[])
{
    int             i,
                    j,
                    nb,
                    ind,
                    i_len;
    char            ch1,
                   *k0,
                   *k;
    math_rec       *D;
    flow_data      *flow_interp;
    FILE           *S;

    INIT_FLOW(flow_interp);
    i_len = 100 + strlen(argv[1]);
    k = (char *) malloc((size_t) i_len * sizeof(char));
    sprintf(k, "%s/DB.STR", argv[1]);
    S = fopen(k, "r");
    if (S == NULL) {
        error_mess(flow_interp, 8);
        ind = 1;
        goto end;
    }
    nb = 0;
    fscanf(S, "%d", &nb);
    if (nb <= 0) {
        error_mess(flow_interp, 10);
        ind = 1;
        goto end;
    }
    fread(&ch1, 1, 1, S);
    D = (math_rec *) malloc((size_t) nb * sizeof(math_rec));
    Dzero(D,nb);
    for (i = 0; i < nb; i++) {
        lec_DB_STR(S, &D[i]);
        nettoie_x2(D[i].titre);
    }

    for (i = 0; i < nb - 1; i++) {
        k0 = D[i].titre;

        for (j = i + 1; j < nb; j++) {
            if (comp(k0, D[j].titre) == 1)
                printf("%s %s\n", D[i].ref, D[j].ref);
        }
    }

end:  fclose(S);
    free(k);
    return 0;
}
/*------------------------------------------------------------------*/








