;/*************************************************************************
** STR V3.1                                                              **
** liste.h                                                               **
** Copyright (C) 2012  Jean-Marc Drezet                                  **
**                                                                       **
**  This library is free software; you can redistribute it and/or        **
**  modify it under the terms of the GNU Library General Public          **
**  License as published by the Free Software Foundation; either         **
**  version 2 of the License, or (at your option) any later version.     **
**                                                                       **
**  This library is distributed in the hope that it will be useful,      **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    **
**  Library General Public License for more details.                     **
**                                                                       **
**  You should have received a copy of the GNU Library General Public    **
**  License along with this library; if not, write to the Free           **
**  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   **
**                                                                       **
** Please mail any bug reports/fixes/enhancements to me at:              **
**      drezet@math.jussieu.fr                                           **
** or                                                                    **
**      Jean-Marc Drezet                                                 **
**      Institut de Mathematiques de Jussieu                             **
**      UMR 7586 du CNRS                                                 **
**      4, place Jussieu                                                 **
**      75252 Paris                                                      **
**      France                                                           **
**                                                                       **
**************************************************************************/
#ifndef _LIST_ART
#define _LIST_ART

#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>

#define isax(c) (c>='a' && c<='z') || c=='.' || c=='\'' || (c>='A'&& c<='Z')

typedef struct
{
   int              fill;
   char*            fic;
   int              nb_aut;              /* Nombre d'auteurs */
   char**           name_aut;            /* Noms des auteurs */
   char**           name_aut2;           /* Noms des auteurs */
   char*            titre;               /* Titre            */
   char*            resume;              /* Rfrence       */
   char*            ref;
} math_rec;

int                 n_up,
                    n_art;


int             extr_str(char *, char *, char *, char ***, int, int);
int             est_avantb(char *, char *);
int             lect_fic_art(char *, math_rec *);
int             add_DB_STR(FILE *, math_rec *);
int             lec_DB_STR(FILE *, math_rec *);
int             reorder_DB(char *);
void            extr_nam(char *, char **);
void            clean_fic(char *);
void            Squel_fix(void);
size_t          fwrite_html_0(int, FILE *);
void            fwrite_STR_html_0(char *, FILE *);
void            _B_html_0(FILE *);
void            _br_html_0(FILE *);
void            _nbsp_html_0(FILE *);
void            _HREF_deb_html_0(FILE *);
void            _HREF_fin_html_0(FILE *);
void            _invA_html_0(FILE *);
void            _invB_html_0(FILE *);
void            _string_html_0(char *, FILE *);
void            _line_50_html_0(FILE *);
void            _line_75_html_0(FILE *);
void            _line_100_html_0(FILE *);
void            _italic_html_0(FILE *);
void            _invspan_html_0(FILE *S);
void            _color_html_0(FILE *, int, int, int);
void            _big_html_0(FILE *);
void            _invbig_html_0(FILE *);
void            _link_html_0(char *, char *, FILE *);
void            _fontsize_html_0(int , FILE *);
void            _invfont_html_0(FILE *);
void            echange_nom_b(char **, char **);
void            file_param(FILE *, int *, int *, int *);
void            lit_file(FILE *S, char ***, int *, int *, int);
void            init_STR(void);
void            Dzero(math_rec *, int);
void            Dfree(math_rec *, int);
void            nettoie_x(char *);
void            nettoie_x2(char *);
void            STR_exit(int);
void            clean_resume(char *, char **);

/*-------------------------------------------------
    Commandes
-------------------------------------------------*/
int             ls_dir(int argc, char *argv[]);
int             lect_DB(int argc, char *argv[]);
int             update_DB(int argc, char *argv[]);
int             make_html(int argc, char *argv[]);
int             purge_dir(int argc, char *argv[]);
int             lst_autres(int argc, char *argv[]);
int             liste_auteurs_arxiv(int argc, char *argv[]);
int             lst_aut_aut(int argc, char *argv[]);
int             mix_arxiv_aut(int argc, char *argv[]);
int             make_html2(int argc, char *argv[]);
int             init_dir(int argc, char *argv[]);
int             find_dup(int argc, char *argv[]);
int             find_dup2(int argc, char *argv[]);

#endif
