/*************************************************************************
** interpcom-3.2   (command interpreter)                                 **
** main.c : test program for the command interpreter                     **
**          Minimal application with external initialization file        **
**                                                                       **
** Copyright (C) 2006  Jean-Marc Drezet                                  **
**                                                                       **
**  This library is free software; you can redistribute it and/or        **
**  modify it under the terms of the GNU Library General Public          **
**  License as published by the Free Software Foundation; either         **
**  version 2 of the License, or (at your option) any later version.     **
**                                                                       **
**  This library is distributed in the hope that it will be useful,      **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    **
**  Library General Public License for more details.                     **
**                                                                       **
**  You should have received a copy of the GNU Library General Public    **
**  License along with this library; if not, write to the Free           **
**  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   **
**                                                                       **
** Please mail any bug reports/fixes/enhancements to me at:              **
**      drezet@math.jussieu.fr                                           **
** or                                                                    **
**      Jean-Marc Drezet                                                 **
**      Institut de Mathematiques de Jussieu                             **
**      UMR 7586 du CNRS                                                 **
**      4, place Jussieu                                                 **
**      75252 Paris                                                      **
**      France                                                           **
**                                                                       **
 *************************************************************************/

#include "interp.h"
#include "liste.h"

extern int          art_nb;
extern char         art_str[];
FUNCTION           *Funcs;
FUNCTIONC          *Funcs_C;


pfi                proc_str[]={
    ls_dir,
    lect_DB,
    update_DB,
    make_html,
    purge_dir,
    lst_autres,
    liste_auteurs_arxiv,
    lst_aut_aut,
    mix_arxiv_aut,
    make_html2,
    init_dir,
    find_dup,
    find_dup2,
    NULL,
};

pfi                *proc[]={
    proc_str,
    NULL,
};

FUNCTIONGen        *Funcs_Gen[] = {
    NULL,
};

pfib                procb_user[] = {
    NULL,
};

char               *namesb_user[] = {
    "",
};

/*char               *init0;*/
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------

--------------------------------------------------------------------*/
int
main(int argc, char *argv[])
{
    Funcs = Funcs_interp;
    Funcs_C = Funcs_interp_C;
    _NBFONC = _NBFONC0;
    _NBFONC_C = _NBFONC0_C;
    User_Init_File = NULL;
    n_up = 0;
    Squel_fix();
    init_STR();
    prog_c(argc, argv,  NULL, art_str, art_nb, NULL, 0);
/*    free(init0);*/
    STR_exit(1);
    return 0;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------

--------------------------------------------------------------------*/
void
init_prog(flow_data *flow_interp)
{
}

void
init_thread_param(flow_data *flow_interp)
{
}

void init_expr_GEN(flow_data *flow_interp)
{
}

void
clean_thread_param(flow_data *flow_interp)
{
}

void
exit_prog()
{
    STR_exit(0);
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------

--------------------------------------------------------------------*/
void
dest_prop(int typ, int i0, flow_data *flow_interp)
{
    int             i;
    char          **e;
    math_rec       *D;

    if (typ == 0) {
        e = (char **) Obj[0][i0].adresse;
        D = (math_rec *) e[0];
        if (D->nb_aut > 0) {
            for (i = 0; i < D->nb_aut; i++) {
                if (D->name_aut[i] != NULL)
                 free(D->name_aut[i]);
                if (D->name_aut2[i] != NULL)
                 free(D->name_aut2[i]);
            }

            free(D->name_aut);
            free(D->name_aut2);
            free(D->titre);
            free(D->resume);
            if (D->ref != NULL)
                free(D->ref);
            if (D->fic != NULL)
                free(D->fic);
        }
        free(D);
    }
}
/*------------------------------------------------------------------*/





/*--------------------------------------------------------------------

--------------------------------------------------------------------*/
void
init_STR(void)
{
    int             l,
                    lin,
                    len,
                    len2;
    char           *base_dir,
                   *init_file,
                   *init_file2;
    FILE           *init;

    init_file = ch_copy(".listerc3");
    l = strlen(getenv("HOME")) + strlen(init_file) + 10;
    init_file2 = (char *) malloc((size_t) l * sizeof(char));
    memset(init_file2, 0, l);
    sprintf(init_file2, "%s/%s", getenv("HOME"), init_file);
    free(init_file);
    init = fopen(init_file2, "r");
    if (init == NULL) {
        printf("Fichier ~/.listerc3 absent\n");
        exit(0);
    }
    file_param(init, &lin, &len, &len2);
    base_dir = (char *) malloc((size_t) (len + 10) * sizeof(char *));
    memset(base_dir, 0, len + 10);
    if (fscanf(init, "%s", base_dir) != 1) {
        printf("Fichier ~/.listerc3 incorrect (1)\n");
        exit(0);
    }
    fclose(init);
/*    init0 = (char *) malloc((size_t) (len + 20) * sizeof(char));
    memset(init0, 0, len + 20);
    sprintf(init0, "%s/art1.ini", base_dir);*/
    free(base_dir);
    free(init_file2);
}
/*------------------------------------------------------------------*/





/*--------------------------------------------------------------------

--------------------------------------------------------------------*/
void
STR_exit(int i0)
{
         if (i0 == 0)
             printf("STR successfully executed\n");
         else
             printf("Error %d detected\n", i0);
         exit(0);
}
/*------------------------------------------------------------------*/
