/*************************************************************************
** STR V3.1                                                              **
** xx.c                                                                  **
** Copyright (C) 2012  Jean-Marc Drezet                                  **
**                                                                       **
**  This library is free software; you can redistribute it and/or        **
**  modify it under the terms of the GNU Library General Public          **
**  License as published by the Free Software Foundation; either         **
**  version 2 of the License, or (at your option) any later version.     **
**                                                                       **
**  This library is distributed in the hope that it will be useful,      **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    **
**  Library General Public License for more details.                     **
**                                                                       **
**  You should have received a copy of the GNU Library General Public    **
**  License along with this library; if not, write to the Free           **
**  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   **
**                                                                       **
** Please mail any bug reports/fixes/enhancements to me at:              **
**      drezet@math.jussieu.fr                                           **
** or                                                                    **
**      Jean-Marc Drezet                                                 **
**      Institut de Mathematiques de Jussieu                             **
**      UMR 7586 du CNRS                                                 **
**      4, place Jussieu                                                 **
**      75252 Paris                                                      **
**      France                                                           **
**                                                                       **
**************************************************************************/
#include <stdlib.h>
#include <gtk-2.0/gtk/gtk.h>
#include <pthread.h>
#include <string.h>

pthread_attr_t      attr,
                    attr2;
pthread_t         **thread0,
                  **thread2;
int                 i_thread,
                    i_thread2;
char                kw[10];               

struct _XXW
{
    GtkWidget *FEN;
    GtkWidget *BV;
    GtkWidget *champ1;
    GtkWidget *champ2;
};

typedef struct _XXW XXW;

int             See_main(int argc, char *argv[]);
void            OnUpdate(GtkWidget *champ1, gpointer data);
void            OnUpdate2(GtkWidget *champ1, gpointer data);
void           *AX(void *);
void           *AX2(void *);
int             read_DIRS(void);
char           *ch_copy(char *);




/*--------------------------------------------------------------------
--------------------------------------------------------------------*/
int
main(int argc, char **argv)
{
    XXW     *MW;
    int             i;

    if (read_DIRS() == 1) {
        printf("problème de lecture de ~/.listerc3\n");
        exit(0);
    }

    thread0 = (pthread_t **) malloc((size_t) 1000 * sizeof(pthread_t *));
    thread2 = (pthread_t **) malloc((size_t) 1000 * sizeof(pthread_t *));

    for (i = 0; i < 1000; i++) {
        thread0[i] = (pthread_t *) malloc(sizeof(pthread_t));
        thread2[i] = (pthread_t *) malloc(sizeof(pthread_t));
    }

    i_thread = 0;
    i_thread2 = 0;
    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);

    gtk_init(&argc, &argv);
    MW = g_malloc(sizeof(XXW));
    MW->FEN = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(MW->FEN), "xxw");
    gtk_window_set_default_size(GTK_WINDOW(MW->FEN), 80, 80);
    g_signal_connect(G_OBJECT(MW->FEN), "destroy",
        G_CALLBACK(gtk_main_quit), NULL);
    MW->BV = gtk_vbox_new(TRUE, 0);
    gtk_container_add(GTK_CONTAINER(MW->FEN), MW->BV);
    MW->champ1 = gtk_entry_new();
    MW->champ2 = gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(MW->BV), MW->champ1, TRUE, FALSE, 0);
    gtk_box_pack_start(GTK_BOX(MW->BV), MW->champ2, TRUE, FALSE, 0);
    g_signal_connect(G_OBJECT(MW->champ1), "activate", G_CALLBACK(OnUpdate),
        (gpointer) MW);
    g_signal_connect(G_OBJECT(MW->champ2), "activate", G_CALLBACK(OnUpdate2),
        (gpointer) MW);

    gtk_widget_show_all(MW->FEN);
    gtk_main();
    g_free(MW);
    return EXIT_SUCCESS;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
 Fonction callback executee lors du signal "activate"
--------------------------------------------------------------------*/
void
OnUpdate(GtkWidget *champ1, gpointer w)
{
    const gchar    *sText;
    XXW     *MW;
    void           *U;

    MW = (XXW*) w;
    sText = gtk_entry_get_text(GTK_ENTRY(MW->champ1));
    U = ch_copy((char *) sText);
    pthread_create(thread0[i_thread], &attr, AX, U);
    i_thread++;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
 Fonction callback executee lors du signal "activate"
--------------------------------------------------------------------*/
void
OnUpdate2(GtkWidget *champ1, gpointer data)
{
    const gchar    *sText;
    XXW     *MW;
    void           *U;

    MW = (XXW*) data;
    sText = gtk_entry_get_text(GTK_ENTRY(MW->champ2));
    U = (void *) sText;
    pthread_create(thread2[i_thread2], &attr, AX2, U);
    i_thread2++;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
--------------------------------------------------------------------*/
void
*AX(void *XX)
{
    char           *k,
                  **k0;
    int             len;

    k = (char *) XX;
    len = strlen(k);
    k0 = (char **) malloc((size_t) 3 * sizeof(char *));
    k0[1] = k;
    k0[0] = kw;
    See_main(2, k0);
    return NULL;
}
/*------------------------------------------------------------------*/




/*--------------------------------------------------------------------
--------------------------------------------------------------------*/
void
*AX2(void *XX)
{
    char           *k,
                  **k0;
    int             len;

    k = (char *) XX;
    len = strlen(k);
    k0 = (char **) malloc((size_t) 4 * sizeof(char *));
    k0[1] = "-a";
    k0[2] = k;
    k0[0] = kw;
    See_main(3, k0);
    return NULL;
}
/*------------------------------------------------------------------*/

